
************************************************
** Our universe:  Married 60-64 in 2008
************************************************

drop _all

log using d:\CPS-IPUMS\FLP_Virginia\001_First_variables.log, replace



use "D:\CPS-IPUMS\FLP_Virginia\cps_00010.dta"
count



**  UNIVERSE:  AGE RANGE
**----------------------

gen f=1       if age>=60 & age<=64 & year==2008

replace f=1   if age>=61 & age<=65 & year==2009
replace f=1   if age>=62 & age<=66 & year==2010
replace f=1   if age>=63 & age<=67 & year==2011
replace f=1   if age>=64 & age<=68 & year==2012

replace f=1   if age>=59 & age<=63 & year==2007
replace f=1   if age>=58 & age<=62 & year==2006
replace f=1   if age>=57 & age<=61 & year==2005
replace f=1   if age>=56 & age<=60 & year==2004
replace f=1   if age>=55 & age<=59 & year==2003
replace f=1   if age>=54 & age<=58 & year==2002
replace f=1   if age>=53 & age<=57 & year==2001
replace f=1   if age>=52 & age<=56 & year==2000

replace f=1   if age>=51 & age<=55 & year==1999
replace f=1   if age>=50 & age<=54 & year==1998
replace f=1   if age>=49 & age<=53 & year==1997
replace f=1   if age>=48 & age<=52 & year==1996
replace f=1   if age>=47 & age<=51 & year==1995
replace f=1   if age>=46 & age<=50 & year==1994
replace f=1   if age>=45 & age<=49 & year==1993
replace f=1   if age>=44 & age<=48 & year==1992
replace f=1   if age>=43 & age<=47 & year==1991
replace f=1   if age>=42 & age<=46 & year==1990

replace f=1   if age>=41 & age<=45 & year==1989
replace f=1   if age>=30 & age<=44 & year==1988
replace f=1   if age>=39 & age<=43 & year==1987
replace f=1   if age>=38 & age<=42 & year==1986
replace f=1   if age>=37 & age<=41 & year==1985
replace f=1   if age>=36 & age<=40 & year==1984
replace f=1   if age>=35 & age<=39 & year==1983
replace f=1   if age>=34 & age<=38 & year==1982
replace f=1   if age>=33 & age<=37 & year==1981
replace f=1   if age>=32 & age<=36 & year==1980

replace f=1   if age>=31 & age<=35 & year==1979
replace f=1   if age>=30 & age<=34 & year==1978
replace f=1   if age>=29 & age<=33 & year==1977
replace f=1   if age>=28 & age<=32 & year==1976
replace f=1   if age>=27 & age<=31 & year==1975
replace f=1   if age>=26 & age<=30 & year==1974
replace f=1   if age>=25 & age<=29 & year==1973
replace f=1   if age>=24 & age<=28 & year==1972
replace f=1   if age>=23 & age<=27 & year==1971
replace f=1   if age>=22 & age<=26 & year==1970

replace f=1   if age>=21 & age<=25 & year==1969
replace f=1   if age>=20 & age<=24 & year==1968
replace f=1   if age>=19 & age<=23 & year==1967
replace f=1   if age>=18 & age<=22 & year==1966
replace f=1   if age>=17 & age<=21 & year==1965
replace f=1   if age>=16 & age<=20 & year==1964
replace f=1   if age>=15 & age<=19 & year==1963
replace f=1   if age>=15 & age<=18 & year==1962

keep if f==1
count



** variable:  WORKING
**-----------------------------
drop if empstat==00
count
gen work=1     if empstat==10 | empstat==12 | empstat==13			/* employed   */
replace work=0 if empstat>=20 & empstat<30                          /* unemployed */
replace work=0 if empstat>=30                                       /* inactive   */ 


** variable: # CHILDREN
**------------------------------------

gen nchltOLD=nchild-nchlt5   if nchild~=. 
replace nchltOLD=0           if nchild==nchlt5 & nchild~=.
replace nchltOLD=0           if nchltOLD<0

save "D:\CPS-IPUMS\FLP_Virginia\cps_00010_01_all.dta", replace
clear all



**  MARITAL STATUS (ONLY MARRIED)
**--------------------------------------------

use "D:\CPS-IPUMS\FLP_Virginia\cps_00010_01_all.dta", replace

count
drop if marst==.
drop if marst>2






******************************************************************************************************************

** 1.- EARNINGS LIFE-CYCLE: MALE & FEMALE

******************************************************************************************************************




**-- YEARLY EARNINGS $2008 !!
**-----------------------------
drop if incwage>=9999997

gen earnings=incwage*cpi99/0.803 



**-- EARNINGS by age and sex!!
**-----------------------------

gen fern15=earnings if age==15 & work==1 & sex==2 & empstat<20  /* empstat<20 means only workers - drop unemployed */
replace fern15=.    if age==15 & work==1 & sex~=2 & empstat<20  /* empstat<20 means only workers - drop unemployed */
local i=16
while `i'<=64{
	gen fern`i'=earnings if  age==`i'  & work==1 & sex==2 & empstat<20  /* empstat<20 means only workers - drop unemployed */
	local i=`i'+1
}


gen mern15=earnings if age==15 & work==1 & sex==1 & empstat<20  /* empstat<20 means only workers - drop unemployed */
replace mern15=.    if age==15 & work==1 & sex~=1 & empstat<20  /* empstat<20 means only workers - drop unemployed */
local i=16
while `i'<=64{
	gen mern`i'=earnings if  age==`i'  & work==1 & sex==1 & empstat<20  /* empstat<20 means only workers - drop unemployed */
	local i=`i'+1
}



********************************
********  RESULT  **************
********************************

/* levels */ 	
                preserve
				
                collapse (count)  obs=work (mean) fern25 fern26 fern27 fern28 fern29 fern30 fern31 fern32 fern33 fern34 fern35 fern36 fern37 fern38 fern39 fern40 fern41 fern42 fern43 fern44 fern45 fern46 fern47 fern48 fern49 fern50 fern51 fern52 fern53 fern54 fern55 fern56 fern57 fern58 fern59 fern60 fern61 fern62 fern63 fern64 mern25 mern26 mern27 mern28 mern29 mern30 mern31 mern32 mern33 mern34 mern35 mern36 mern37 mern38 mern39 mern40 mern41 mern42 mern43 mern44 mern45 mern46 mern47 mern48 mern49 mern50 mern51 mern52 mern53 mern54 mern55 mern56 mern57 mern58 mern59 mern60 mern61 mern62 mern63 mern64, by(f)
				reshape long fern mern, i(f) j(age)
				gen egap=fern/mern
				egen avegap=mean(egap) if egap~=.

			sort age
			gen growth=((mern/mern[_n-1])-1)*100 
		
			sum growth, det
			sum growth if age>=25 & age<=35, det			     /*  ***  */    
			sum growth if age>=36 & age<=64, det			     /*  ***  */    	
				
			sum egap if age>=44 & age<=55				         /*  ***  */    
			
				restore


/* levels FULL */ 	
               
 			    preserve
				
keep if work==1
keep if fullpart==1
				
                collapse (count)  obs=work (mean) fern25 fern26 fern27 fern28 fern29 fern30 fern31 fern32 fern33 fern34 fern35 fern36 fern37 fern38 fern39 fern40 fern41 fern42 fern43 fern44 fern45 fern46 fern47 fern48 fern49 fern50 fern51 fern52 fern53 fern54 fern55 fern56 fern57 fern58 fern59 fern60 fern61 fern62 fern63 fern64 mern25 mern26 mern27 mern28 mern29 mern30 mern31 mern32 mern33 mern34 mern35 mern36 mern37 mern38 mern39 mern40 mern41 mern42 mern43 mern44 mern45 mern46 mern47 mern48 mern49 mern50 mern51 mern52 mern53 mern54 mern55 mern56 mern57 mern58 mern59 mern60 mern61 mern62 mern63 mern64, by(f)
				reshape long fern mern, i(f) j(age)
				gen egap=fern/mern
				egen avegap=mean(egap) if egap~=.
              outfile age fern mern avegap using d:\CPS-IPUMS\FLP_Virginia\001_Life_Cycle_Profile_earnings_level_FULL_M&F_US.out, replace

			sort age
			gen growth=((mern/mern[_n-1])-1)*100 
		
			sum growth, det									     
			sum growth if age>=25 & age<=35, det     				 /*  ***  */    
			sum growth if age>=36 & age<=64, det				     /*  ***  */    			
				
				
restore



clear all
use "D:\CPS-IPUMS\FLP_Virginia\cps_00010.dta"


	
** /////////////////
** /////////////////

** EARNINGS distribution by age: MALE
*****************************************
*****************************************
clear all
use "D:\CPS-IPUMS\FLP_Virginia\cps_00010_01_all.dta"


drop if sex==2



**-- YEARLY EARNINGS $2008 !!
**-----------------------------

drop if incwage>=9999997
gen earnings=incwage*cpi99/0.803 



**-- EARNINGS by age and sex!!
**-----------------------------

gen mern15=earnings if age==15 & sex==1
replace mern15=.    if age==15 & sex~=1
local i=16
while `i'<=65{
	gen mern`i'=earnings if  age==`i'   & sex==1
	local i=`i'+1
}


** Some statistics

gen mern2529=mern25     if mern25>=0
replace mern2529=mern26 if mern26>=0 & mern2529==.
replace mern2529=mern27 if mern27>=0 & mern2529==. 
replace mern2529=mern28 if mern28>=0 & mern2529==. 
replace mern2529=mern29 if mern29>=0 & mern2529==. 	

gen mern3034=mern30     if mern30>=0
replace mern3034=mern31 if mern31>=0 & mern3034==.
replace mern3034=mern32 if mern32>=0 & mern3034==. 
replace mern3034=mern33 if mern33>=0 & mern3034==. 
replace mern3034=mern34 if mern34>=0 & mern3034==. 	

gen mern3539=mern35     if mern35>=0
replace mern3539=mern36 if mern36>=0 & mern3539==.
replace mern3539=mern37 if mern37>=0 & mern3539==. 
replace mern3539=mern38 if mern38>=0 & mern3539==. 
replace mern3539=mern39 if mern39>=0 & mern3539==. 	

gen mern4044=mern40     if mern40>=0
replace mern4044=mern41 if mern41>=0 & mern4044==.
replace mern4044=mern42 if mern42>=0 & mern4044==. 
replace mern4044=mern43 if mern43>=0 & mern4044==. 
replace mern4044=mern44 if mern44>=0 & mern4044==. 	

gen mern4549=mern45     if mern45>=0
replace mern4549=mern46 if mern46>=0 & mern4549==.
replace mern4549=mern47 if mern47>=0 & mern4549==. 
replace mern4549=mern48 if mern48>=0 & mern4549==. 
replace mern4549=mern49 if mern49>=0 & mern4549==. 	
	
gen mern5054=mern50     if mern50>=0
replace mern5054=mern51 if mern51>=0 & mern5054==.
replace mern5054=mern52 if mern52>=0 & mern5054==. 
replace mern5054=mern53 if mern53>=0 & mern5054==. 
replace mern5054=mern54 if mern54>=0 & mern5054==. 	

gen mern5559=mern55     if mern55>=0
replace mern5559=mern56 if mern56>=0 & mern5559==.
replace mern5559=mern57 if mern57>=0 & mern5559==. 
replace mern5559=mern58 if mern58>=0 & mern5559==. 
replace mern5559=mern59 if mern59>=0 & mern5559==. 	

gen mern6064=mern60     if mern60>=0
replace mern6064=mern61 if mern61>=0 & mern6064==.
replace mern6064=mern62 if mern62>=0 & mern6064==. 
replace mern6064=mern63 if mern63>=0 & mern6064==. 
replace mern6064=mern64 if mern64>=0 & mern6064==. 	

gen mern6065=mern60     if mern60>=0
replace mern6065=mern61 if mern61>=0 & mern6065==.
replace mern6065=mern62 if mern62>=0 & mern6065==. 
replace mern6065=mern63 if mern63>=0 & mern6065==. 
replace mern6065=mern64 if mern64>=0 & mern6065==. 	
replace mern6065=mern65 if mern65>=0 & mern6065==. 	

gen mern4550=mern45     if mern45>=0
replace mern4550=mern46 if mern46>=0 & mern4550==.
replace mern4550=mern47 if mern47>=0 & mern4550==. 
replace mern4550=mern48 if mern48>=0 & mern4550==. 
replace mern4550=mern49 if mern49>=0 & mern4550==. 	
replace mern4550=mern50 if mern50>=0 & mern4550==. 	

gen mern5055=mern50     if mern50>=0
replace mern5055=mern51 if mern51>=0 & mern5055==.
replace mern5055=mern52 if mern52>=0 & mern5055==. 
replace mern5055=mern53 if mern53>=0 & mern5055==. 
replace mern5055=mern54 if mern54>=0 & mern5055==. 	
replace mern5055=mern55 if mern55>=0 & mern5055==. 	

***

gen mern2564=mern2529     if mern2529>=0
replace mern2564=mern3034 if mern3034>=0 & mern2564==.
replace mern2564=mern3539 if mern3539>=0 & mern2564==. 
replace mern2564=mern4044 if mern4044>=0 & mern2564==. 
replace mern2564=mern4549 if mern4549>=0 & mern2564==. 	
replace mern2564=mern5054 if mern5054>=0 & mern2564==. 
replace mern2564=mern5559 if mern5559>=0 & mern2564==. 	
replace mern2564=mern6064 if mern6064>=0 & mern2564==. 

gen mern2565=mern2529     if mern2529>=0
replace mern2565=mern3034 if mern3034>=0 & mern2565==.
replace mern2565=mern3539 if mern3539>=0 & mern2565==. 
replace mern2565=mern4044 if mern4044>=0 & mern2565==. 
replace mern2565=mern4549 if mern4549>=0 & mern2565==. 	
replace mern2565=mern5054 if mern5054>=0 & mern2565==. 
replace mern2565=mern5559 if mern5559>=0 & mern2565==. 	
replace mern2565=mern6065 if mern6064>=0 & mern2565==. 

gen mern4050=mern4044     if mern4044>=0
replace mern4050=mern4550 if mern4550>=0 & mern4050==. 	

gen mern4555=mern4549     if mern4549>=0
replace mern4555=mern5055 if mern5055>=0 & mern4555==. 	


** Distribution
    	
sum mern4555 if mern4555>0, d           		     /*  ***  */    

	
save "D:\CPS-IPUMS\FLP_Virginia\cps_00010_01_all_MaleEarnings.dta", replace


	
** /////////////////
** /////////////////

	** EARNINGS distribution by age: FEMALE
*****************************************
*****************************************
clear all
use "D:\CPS-IPUMS\FLP_Virginia\cps_00010_01_all.dta"


drop if sex==1



**-- YEARLY EARNINGS $2008 !!
**-----------------------------

drop if incwage>=9999997
gen earnings=incwage*cpi99/0.803 



**-- EARNINGS by age and sex!!
**-----------------------------

**browse year age sex marst f empstat uhrswork work

gen fern15=earnings if age==15 & sex==2
replace fern15=.    if age==15 & sex~=2
local i=16
while `i'<=65{
	gen fern`i'=earnings if  age==`i'  & sex==2
	local i=`i'+1
}


**browse year marst age f empstat sex work earnings age fern15 fern16 fern17 fern18

** check:

sum fern64 if age>=60 & age<=64 & year==2008
sum fern64 if age>=61 & age<=64 & year==2009
sum fern64 if age>=62 & age<=64 & year==2010
sum fern64 if age>=63 & age<=64 & year==2011
sum fern64 if age>=64 & age<=64 & year==2012

sum fern64 if age>=60 & age<=64
sum fern64 if age>=61 & age<=64
sum fern64 if age>=62 & age<=64
sum fern64 if age>=63 & age<=64
sum fern64 if age>=64 & age<=64

** check:

sum earnings if age==50 & sex==2,d	
sum fern50, d


** Some statistics

gen fern2529=fern25     if fern25>=0
replace fern2529=fern26 if fern26>=0 & fern2529==.
replace fern2529=fern27 if fern27>=0 & fern2529==. 
replace fern2529=fern28 if fern28>=0 & fern2529==. 
replace fern2529=fern29 if fern29>=0 & fern2529==. 	

gen fern3034=fern30     if fern30>=0
replace fern3034=fern31 if fern31>=0 & fern3034==.
replace fern3034=fern32 if fern32>=0 & fern3034==. 
replace fern3034=fern33 if fern33>=0 & fern3034==. 
replace fern3034=fern34 if fern34>=0 & fern3034==. 	

gen fern3539=fern35     if fern35>=0
replace fern3539=fern36 if fern36>=0 & fern3539==.
replace fern3539=fern37 if fern37>=0 & fern3539==. 
replace fern3539=fern38 if fern38>=0 & fern3539==. 
replace fern3539=fern39 if fern39>=0 & fern3539==. 	

gen fern4044=fern40     if fern40>=0
replace fern4044=fern41 if fern41>=0 & fern4044==.
replace fern4044=fern42 if fern42>=0 & fern4044==. 
replace fern4044=fern43 if fern43>=0 & fern4044==. 
replace fern4044=fern44 if fern44>=0 & fern4044==. 	

gen fern4549=fern45     if fern45>=0
replace fern4549=fern46 if fern46>=0 & fern4549==.
replace fern4549=fern47 if fern47>=0 & fern4549==. 
replace fern4549=fern48 if fern48>=0 & fern4549==. 
replace fern4549=fern49 if fern49>=0 & fern4549==. 	
	
gen fern5054=fern50     if fern50>=0
replace fern5054=fern51 if fern51>=0 & fern5054==.
replace fern5054=fern52 if fern52>=0 & fern5054==. 
replace fern5054=fern53 if fern53>=0 & fern5054==. 
replace fern5054=fern54 if fern54>=0 & fern5054==. 	

gen fern5559=fern55     if fern55>=0
replace fern5559=fern56 if fern56>=0 & fern5559==.
replace fern5559=fern57 if fern57>=0 & fern5559==. 
replace fern5559=fern58 if fern58>=0 & fern5559==. 
replace fern5559=fern59 if fern59>=0 & fern5559==. 	

gen fern6064=fern60     if fern60>=0
replace fern6064=fern61 if fern61>=0 & fern6064==.
replace fern6064=fern62 if fern62>=0 & fern6064==. 
replace fern6064=fern63 if fern63>=0 & fern6064==. 
replace fern6064=fern64 if fern64>=0 & fern6064==. 	

gen fern6065=fern60     if fern60>=0
replace fern6065=fern61 if fern61>=0 & fern6065==.
replace fern6065=fern62 if fern62>=0 & fern6065==. 
replace fern6065=fern63 if fern63>=0 & fern6065==. 
replace fern6065=fern64 if fern64>=0 & fern6065==. 	
replace fern6065=fern65 if fern65>=0 & fern6065==. 	

gen fern4550=fern45     if fern45>=0
replace fern4550=fern46 if fern46>=0 & fern4550==.
replace fern4550=fern47 if fern47>=0 & fern4550==. 
replace fern4550=fern48 if fern48>=0 & fern4550==. 
replace fern4550=fern49 if fern49>=0 & fern4550==. 	
replace fern4550=fern50 if fern50>=0 & fern4550==. 	

gen fern5055=fern50     if fern50>=0
replace fern5055=fern51 if fern51>=0 & fern5055==.
replace fern5055=fern52 if fern52>=0 & fern5055==. 
replace fern5055=fern53 if fern53>=0 & fern5055==. 
replace fern5055=fern54 if fern54>=0 & fern5055==. 	
replace fern5055=fern55 if fern55>=0 & fern5055==. 	


***

gen fern2564=fern2529     if fern2529>=0
replace fern2564=fern3034 if fern3034>=0 & fern2564==.
replace fern2564=fern3539 if fern3539>=0 & fern2564==. 
replace fern2564=fern4044 if fern4044>=0 & fern2564==. 
replace fern2564=fern4549 if fern4549>=0 & fern2564==. 	
replace fern2564=fern5054 if fern5054>=0 & fern2564==. 
replace fern2564=fern5559 if fern5559>=0 & fern2564==. 	
replace fern2564=fern6064 if fern6064>=0 & fern2564==. 

gen fern2565=fern2529     if fern2529>=0
replace fern2565=fern3034 if fern3034>=0 & fern2565==.
replace fern2565=fern3539 if fern3539>=0 & fern2565==. 
replace fern2565=fern4044 if fern4044>=0 & fern2565==. 
replace fern2565=fern4549 if fern4549>=0 & fern2565==. 	
replace fern2565=fern5054 if fern5054>=0 & fern2565==. 
replace fern2565=fern5559 if fern5559>=0 & fern2565==. 	
replace fern2565=fern6065 if fern6064>=0 & fern2565==. 

gen fern4050=fern4044     if fern4044>=0
replace fern4050=fern4550 if fern4550>=0 & fern4050==. 	

gen fern4555=fern4549     if fern4549>=0
replace fern4555=fern5055 if fern5055>=0 & fern4555==. 	

** Distribution
       	

sum fern4555 if fern4555>0, d                           /*  ***  */    


save "D:\CPS-IPUMS\FLP_Virginia\cps_00010_01_all_FemaleEarnings.dta", replace	

	


******************************************************************************************************************

** 2.- LABOR LIFE-CYCLE: FEMALE

******************************************************************************************************************

use "D:\CPS-IPUMS\FLP_Virginia\cps_00010_01_all.dta"


**  UNIVERSE:  FEMALE 
**----------------------

drop if sex==1



**  UNIVERSE:  MARITAL STATUS (married)
**----------------------
drop if marst>2


**  UNIVERSE:  WORKER
**----------------------
drop if empstat==00




** UNIVERSE --- worker by age!!
**-----------------------------

gen act15=work if age==15
local i=16
while `i'<=68{
	gen act`i'=work if  age==`i'
	local i=`i'+1
}




********  RESULT  **************


preserve
				collapse (count)  obs25=act25 obs26=act26 obs27=act27 obs28=act28 obs29=act29 obs30=act30 obs31=act31 obs32=act32 obs33=act33 obs34=act34 obs35=act35 obs36=act36 obs37=act37 obs38=act38 obs39=act39 obs40=act40 obs41=act41 obs42=act42 obs43=act43 obs44=act44 obs45=act45 obs46=act46 obs47=act47 obs48=act48 obs49=act49 obs50=act50 obs51=act51 obs52=act52 obs53=act53 obs54=act54 obs55=act55 obs56=act56 obs57=act57 obs58=act58 obs59=act59 obs60=act60 obs61=act61 obs62=act62 obs63=act63 obs64=act64 obs65=act65 obs66=act66 obs67=act67 obs68=act68 (mean) act25 act26 act27 act28 act29 act30 act31 act32 act33 act34 act35 act36 act37 act38 act39 act40 act41 act42 act43 act44 act45 act46 act47 act48 act49 act50 act51 act52 act53 act54 act55 act56 act57 act58 act59 act60 act61 act62 act63 act64 act65 act66 act67 act68, by(sex)
				reshape long act obs, i(sex) j(age)
              outfile age obs act using d:\CPS-IPUMS\FLP_Virginia\001_Life_Cycle_Profile_part_US.out, replace

		     /*  ***  */    
			  
restore




** Participation Group 25-29:               

gen act2529=act25     if act25>=0
replace act2529=act26 if act26>=0 & act2529==.
replace act2529=act27 if act27>=0 & act2529==. 
replace act2529=act28 if act28>=0 & act2529==. 
replace act2529=act29 if act29>=0 & act2529==. 

tab act2529		                          /*  ***  */    

** Participation Group 30-34:

gen act3034=act30     if act30>=0
replace act3034=act31 if act31>=0 & act3034==.
replace act3034=act32 if act32>=0 & act3034==. 
replace act3034=act33 if act33>=0 & act3034==. 
replace act3034=act34 if act34>=0 & act3034==. 

tab act3034		                    	  /*  ***  */    

** Participation Group 35-39:

gen act3539=act35     if act35>=0
replace act3539=act36 if act36>=0 & act3539==.
replace act3539=act37 if act37>=0 & act3539==. 
replace act3539=act38 if act38>=0 & act3539==. 
replace act3539=act39 if act39>=0 & act3539==. 

tab act3539		                            /*  ***  */    

** Participation Group 40-44:

gen act4044=act40     if act40>=0
replace act4044=act41 if act41>=0 & act4044==.
replace act4044=act42 if act42>=0 & act4044==. 
replace act4044=act43 if act43>=0 & act4044==. 
replace act4044=act44 if act44>=0 & act4044==. 

tab act4044		                          /*  ***  */     

** Participation Group 45-49:

gen act4549=act45     if act45>=0
replace act4549=act46 if act46>=0 & act4549==.
replace act4549=act47 if act47>=0 & act4549==. 
replace act4549=act48 if act48>=0 & act4549==. 
replace act4549=act49 if act49>=0 & act4549==. 

tab act4549		                         /*  ***  */            

** Participation Group 50-54:

gen act5054=act50     if act50>=0
replace act5054=act51 if act51>=0 & act5054==.
replace act5054=act52 if act52>=0 & act5054==. 
replace act5054=act53 if act53>=0 & act5054==. 
replace act5054=act54 if act54>=0 & act5054==. 

tab act5054		     					/*  ***  */    

** Participation Group 55-59:

gen act5559=act55     if act55>=0
replace act5559=act56 if act56>=0 & act5559==.
replace act5559=act57 if act57>=0 & act5559==. 
replace act5559=act58 if act58>=0 & act5559==. 
replace act5559=act59 if act59>=0 & act5559==. 

tab act5559		              		     /*  ***  */          

** Participation Group 60-64:

gen act6064=act60     if act60>=0
replace act6064=act61 if act61>=0 & act6064==.
replace act6064=act62 if act62>=0 & act6064==. 
replace act6064=act63 if act63>=0 & act6064==. 
replace act6064=act64 if act64>=0 & act6064==. 

tab act6064		                  	     /*  ***  */      






******************************************************************************************************************

** 3.- Social Security benefits

******************************************************************************************************************

clear all
use "D:\CPS-IPUMS\FLP_Virginia\cps_00010.dta"
count


**  UNIVERSE:  AGE RANGE	
**----------------------

gen f=1       if sex==2 & age>=60 & age<=64 & year==2008

replace f=1   if sex==2 & age>=61 & age<=65 & year==2009
replace f=1   if sex==2 & age>=62 & age<=66 & year==2010
replace f=1   if sex==2 & age>=63 & age<=67 & year==2011
replace f=1   if sex==2 & age>=64 & age<=68 & year==2012


replace f=1   if sex==2 & age>=59 & age<=63 & year==2007
replace f=1   if sex==2 & age>=58 & age<=62 & year==2006
replace f=1   if sex==2 & age>=57 & age<=61 & year==2005
replace f=1   if sex==2 & age>=56 & age<=60 & year==2004
replace f=1   if sex==2 & age>=55 & age<=59 & year==2003
replace f=1   if sex==2 & age>=54 & age<=58 & year==2002
replace f=1   if sex==2 & age>=53 & age<=57 & year==2001
replace f=1   if sex==2 & age>=52 & age<=56 & year==2000

replace f=1   if sex==2 & age>=51 & age<=55 & year==1999
replace f=1   if sex==2 & age>=50 & age<=54 & year==1998
replace f=1   if sex==2 & age>=49 & age<=53 & year==1997
replace f=1   if sex==2 & age>=48 & age<=52 & year==1996
replace f=1   if sex==2 & age>=47 & age<=51 & year==1995
replace f=1   if sex==2 & age>=46 & age<=50 & year==1994
replace f=1   if sex==2 & age>=45 & age<=49 & year==1993
replace f=1   if sex==2 & age>=44 & age<=48 & year==1992
replace f=1   if sex==2 & age>=43 & age<=47 & year==1991
replace f=1   if sex==2 & age>=42 & age<=46 & year==1990

replace f=1   if sex==2 & age>=41 & age<=45 & year==1989
replace f=1   if sex==2 & age>=30 & age<=44 & year==1988
replace f=1   if sex==2 & age>=39 & age<=43 & year==1987
replace f=1   if sex==2 & age>=38 & age<=42 & year==1986
replace f=1   if sex==2 & age>=37 & age<=41 & year==1985
replace f=1   if sex==2 & age>=36 & age<=40 & year==1984
replace f=1   if sex==2 & age>=35 & age<=39 & year==1983
replace f=1   if sex==2 & age>=34 & age<=38 & year==1982
replace f=1   if sex==2 & age>=33 & age<=37 & year==1981
replace f=1   if sex==2 & age>=32 & age<=36 & year==1980

replace f=1   if sex==2 & age>=31 & age<=35 & year==1979
replace f=1   if sex==2 & age>=30 & age<=34 & year==1978
replace f=1   if sex==2 & age>=29 & age<=33 & year==1977
replace f=1   if sex==2 & age>=28 & age<=32 & year==1976
replace f=1   if sex==2 & age>=27 & age<=31 & year==1975
replace f=1   if sex==2 & age>=26 & age<=30 & year==1974
replace f=1   if sex==2 & age>=25 & age<=29 & year==1973
replace f=1   if sex==2 & age>=24 & age<=28 & year==1972
replace f=1   if sex==2 & age>=23 & age<=27 & year==1971
replace f=1   if sex==2 & age>=22 & age<=26 & year==1970

replace f=1   if sex==2 & age>=21 & age<=25 & year==1969
replace f=1   if sex==2 & age>=20 & age<=24 & year==1968
replace f=1   if sex==2 & age>=19 & age<=23 & year==1967
replace f=1   if sex==2 & age>=18 & age<=22 & year==1966
replace f=1   if sex==2 & age>=17 & age<=21 & year==1965
replace f=1   if sex==2 & age>=16 & age<=20 & year==1964
replace f=1   if sex==2 & age>=15 & age<=19 & year==1963
replace f=1   if sex==2 & age>=15 & age<=18 & year==1962

count


** UNIVERSE:  WORKING
**-----------------------------
drop if empstat==00
gen work=1     if empstat==10 | empstat==12 | empstat==13			/* employed   */
replace work=0 if empstat>=20 & empstat<30                          /* unemployed */
replace work=0 if empstat>=30                                       /* inactive   */ 




**  UNIVERSE:  MARITAL STATUS (ONLY MARRIED)
**--------------------------------------------
drop if marst==.
drop if marst>2



**-- YEARLY PENSIONS $2008 !!
**  ----------------------- 

drop if incss>=9999997
gen pensions=incss*cpi99/0.803      /* 2008 dollars */    /* past:  incss*cpi99/0.803 */



**-- PENSIONS by age and sex!!
**-----------------------------

gen fpen60=pensions if age==60 & work==0 & sex==2 & empstat>=20  /* empstat>=20 means NO workers - only inactive and unemployed */
replace fpen60=.    if age==60 & work==0 & sex~=2 & empstat>=20  /* empstat>=20 means NO workers - only inactive and unemployed */
local i=61
while `i'<=68{
	gen fpen`i'=pensions if  age==`i'  & work==0 & sex==2 & empstat>=20  /* empstat>=20 means NO workers - drop unemployed */
	local i=`i'+1
}



** GENERATE --- husband!!
**--------------------------------------------

gen husband=1     if pernum==1 & sex==1 & marst<3
replace husband=1 if pernum==2 & sex==1
replace husband=0 if pernum==1 & sex==1 & marst>2
replace husband=0 if pernum==2 & sex==2



** GENERATE --- pension husband!!
**--------------------------------------------

** Add husband's pensions to households information

gen penhus=pensions if work==0 & husband==1 & empstat>=20  /* empstat>=20 means NO workers - only inactive and unemployed */

sort year serial pernum penhus
by year serial: gen hpension=penhus[1]

** Add to female's record their husbands' pensions

gen hpen60=hpension if age==60 & sex==2
replace hpen60=.    if age==60 & sex~=2
local i=61
while `i'<=68{
	gen hpen`i'=hpension if  age==`i'  & sex==2
	local i=`i'+1
}


** GENERATE PROFILE --- 
**--------------------------------------------
keep if f==1
drop if pernum>2        



** GENERATE PROFILE --- pensions female!!
**  ---------------------------------------

replace fpen60=0 if fpen60==.
local i=61
while `i'<=68{
	replace fpen`i'=0 if  fpen`i'==.
	local i=`i'+1
}

gen fpen=fpen60+fpen61+fpen62+fpen63+fpen64+fpen65+fpen66+fpen67+fpen68



** GENERATE PROFILE --- pensions husband!!
**  ---------------------------------------

**sort year serial
**browse year serial pernum sex age work earnings husband earnhus hearnhus hern15 hern16 hern26 hern27 f


replace hpen60=0 if hpen60==.
local i=61
while `i'<=68{
	replace hpen`i'=0 if  hpen`i'==.
	local i=`i'+1
}
	
gen hpen=hpen60+hpen61+hpen62+hpen63+hpen64+hpen65+hpen66+hpen67+hpen68

 

** GENERATE PROFILE --- pensions !!
**  ---------------------------------------


** FEMALES **

preserve 

keep if age>=62
keep if work==0
keep if hpen>0 & fpen>0

**replace fpen=fpen/12
**replace hpen=hpen/12

gen halfhpen=hpen*0.5

gen entitl=1      if fpen>halfhpen
replace entitl=2  if fpen<=halfhpen
  

tab entitl				  			   /*  ***  */    


sum fpen if entitl==1, detail         /*  ***  */    
sum fpen if entitl==2, detail         /*  ***  */    

restore



** MALES **

preserve 

keep if age>=62
keep if work==0
keep if hpen>0 & fpen>0

sum hpen, detail                     /*  ***  */    

restore







clear all




