
************************************************
** Our universe:  Married 60-64 in 2008 
************************************************

drop _all
set mem 5000m
set maxvar 10000

log using D:\RAND_HRS_vN\001_First_variables.log, replace


use "D:\RAND_HRS_vN\rndhrs_n.dta"
count



**UNIVERSE:  
**-----------------
** Married Females aged 60-64 in 2008 --> wave 9

gen f=1      if r9agey_b>=60 & r9agey_b<=64 & ragender==2 & h1cpl==1

replace f=1  if r10agey_b>=62 & r10agey_b<=66 & ragender==2 & h1cpl==1	 
replace f=1  if r11agey_b>=64 & r11agey_b<=68 & ragender==2 & h1cpl==1	 

replace f=1  if r4agey_b>=50 & r4agey_b<=54 & ragender==2 & h1cpl==1	 	 
replace f=1  if r5agey_b>=52 & r5agey_b<=56 & ragender==2 & h1cpl==1	 	 
replace f=1  if r6agey_b>=54 & r6agey_b<=58 & ragender==2 & h1cpl==1	 	 
replace f=1  if r7agey_b>=56 & r7agey_b<=60 & ragender==2 & h1cpl==1	 	  
replace f=1  if r8agey_b>=58 & r8agey_b<=62 & ragender==2 & h1cpl==1	 	 

replace f=2  if s9agey_b>=60 & s9agey_b<=64 & ragender==1     

replace f=2  if s10agey_b>=62 & s10agey_b<=66 & ragender==1	 
replace f=2  if s11agey_b>=64 & s11agey_b<=68 & ragender==1	 

replace f=2  if s4agey_b>=50 & s4agey_b<=54 & ragender==1	 	 
replace f=2  if s5agey_b>=52 & s5agey_b<=56 & ragender==1	 	 
replace f=2  if s6agey_b>=54 & s6agey_b<=58 & ragender==1	 	 
replace f=2  if s7agey_b>=56 & s7agey_b<=60 & ragender==1	 	  
replace f=2  if s8agey_b>=58 & s8agey_b<=62 & ragender==1	 	 


** Keep ONLY married (take care widows)

keep if f<=2 & f~=.
count
tab f


** EXPERIENCE ---  at the YEAR AT WHICH   "FEMALE"   STARTED TO RECEIVE SS            
** ------------------------------------------------------------------------

	
				** WORK HISTORY AT 60 
				** -----------	
	
				gen fexp60=r4jyears       if r4agey_b>=60 & r4agey_b<=61 & f==1 	
				replace fexp60=s4jyears   if s4agey_b>=60 & s4agey_b<=61 & f==2 	
				local i=5
				while `i'<=11{
				replace fexp60=r`i'jyears if r`i'agey_b>=60 & r`i'agey_b<=61 & f==1 	
				replace fexp60=s`i'jyears if s`i'agey_b>=60 & s`i'agey_b<=61 & f==2 	
				local i=`i'+1
				}
				
				**...  report NEVER WORK
				
				replace fexp60=0  if f==1 & fexp60==. & r4jjobs==0	
				replace fexp60=0  if f==2 & fexp60==. & s4jjobs==0	 	
				local i=5
				while `i'<=11{
				replace fexp60=0  if f==1 & fexp60==. & r`i'jjobs==0	 	
				replace fexp60=0  if f==2 & fexp60==. & s`i'jjobs==0	 	
				local i=`i'+1
				}
				
				**... (correcting missing) report # JOBS REPORTED 0
				
				replace fexp60=0  if f==1 & fexp60==. & r4jnjob==0	
				replace fexp60=0  if f==2 & fexp60==. & s4jnjob==0	 	
				local i=5
				while `i'<=11{
				replace fexp60=0  if f==1 & fexp60==. & r`i'jnjob==0	 	
				replace fexp60=0  if f==2 & fexp60==. & s`i'jnjob==0	 	
				local i=`i'+1
				}
				
	
sum fexp60 if fexp60>0,d				         /*  ***  */    

				






log close


