
************************************************
** Our universe:  Married 60-64 in 2008
************************************************

** SIPP:
** - Topical --> wealth data
** - Core --> income data

** We have first to merge "core" and "topical"
	

drop _all
set mem 5000m

log using D:\SIPP\2008_wave4_All\001_First_variables_SIPP.log, replace

**----------------------
**MERGE:  Topical + Core
**----------------------

use D:\SIPP\2008_wave4_Topical\p08putm4.dta
count
sort SWAVE SSUID SSUSEQ EPPPNUM ERRP
save D:\SIPP\2008_wave4_Topical\p08putm4.dta, replace 
use  "D:\SIPP\2008_wave4_Core\l08puw4.dta"
count
sort SWAVE SSUID SSUSEQ EPPPNUM ERRP
merge SWAVE SSUID SSUSEQ EPPPNUM ERRP, using D:\SIPP\2008_wave4_Topical\p08putm4.dta
tab _merge

drop if _merge==1


count
drop if SREFMON<4
count


save D:\SIPP\2008_wave4_All\001_First_variables.dta, replace



				*********************************
				**		 	age>54 & age<65
				*********************************


clear all
use "D:\SIPP\2008_wave4_All\001_First_variables.dta"
count


**----------------
**FIRST variables
**----------------


** RENAME
**********

rename SSUID houseidd
rename SSUSEQ houseid
rename EPPPNUM personid
rename ERRP relhead
rename TAGE age
rename EMS marst
rename ESEX sex
rename THHTNW networth
rename TFTOTINC houseincome
rename THTOTINC famincome
rename WHFNWGT weight



**  UNIVERSE:  AGE RANGE
**----------------------

*********************************
keep if age>54 & age<65
*********************************
count



**  UNIVERSE:  MARRIED HEAD
**-------------------------

count
keep if relhead==1 & marst<3
count


** ////////////////////////////////////////////////////////////////////////////////////////////////////
**  NET WORTH (by INCOME quintile)

**  INCOME
**-------------------------

** Adjust (year)

	replace houseincome = houseincome
	replace famincome = famincome


** quintiles

preserve 

drop if houseincome<0

centile houseincome, centile(20 40 60 80 100)
egen q1=pctile(houseincome), p(20)
egen q2=pctile(houseincome), p(40)
egen q3=pctile(houseincome), p(60)
egen q4=pctile(houseincome), p(80)

gen quintile=1 if houseincome<q1
replace quintile=2 if houseincome>q1 & houseincome<q2
replace quintile=3 if houseincome>q2 & houseincome<q3
replace quintile=4 if houseincome>q3 & houseincome<q4
replace quintile=5 if houseincome>q4
replace quintile=. if houseincome==.

sum networth, d

sort quintile
by quintile: sum networth [aweight=weight], d

table quintile, c (median networth mean networth median houseincome)			         /*  ***  */  

restore



log close

