
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!



module consolve

!here we back out consumption in the simulations by using the 
!envelope theorem and the interpolation routine for the derivative
!of the value function

use params
use subrout
use assetgrid

implicit none

double precision maxinc, valstore

contains


!______________________________________________________________________	

	subroutine valwork( stat, couple, valo, nodeas, nodebit)

	double precision estim1, estim4, intxet, intaet, valo
	integer couple, mina, node, nodeas, nodebit, stat



		call find(age, partcash, nodeas, mina, intaet, intxet, stat)
		node   = nodebit + mina   

		!visitnon(age,mina) = visitnon(age,mina) + 1
		
		estim1   = valemploy(node,age)     
		estim4   = valemploy(node+1, age)  
		valo	 = intaet*estim1 + intxet*estim4
		
	end subroutine valwork
	
	
!______________________________________________________________________	

	subroutine valnonwork( stat, couple, valo, nodeas, nodebit)

	double precision estim1, estim4, intxet, intaet, valo
	integer couple, mina, node, nodeas, nodebit, stat



		call find(age, partcash, nodeas, mina, intaet, intxet, stat)
		node   = nodebit + mina   

		!visitnon(age,mina) = visitnon(age,mina) + 1
		
		
		estim1   = valun(node,age)     
		estim4   = valun(node+1, age)  
		valo	 = intaet*estim1 + intxet*estim4
		
	end subroutine valnonwork
	
	
	
!______________________________________________________________________	

	subroutine valworkcl( stat, couple, valo, nodeas, nodebit)

	double precision estim1, estim4, intxet, intaet, valo
	integer couple, mina, node, nodeas, nodebit, stat



		call findcl(age, partcash, nodeas, mina, intaet, intxet, stat)
		node   = nodebit + mina  

		!visitnon(age,mina) = visitnon(age,mina) + 1
		
		
		estim1   = valemploycl(node,age-ntmin)     
		estim4   = valemploycl(node+1, age-ntmin)  
		valo	 = intaet*estim1 + intxet*estim4
		
	end subroutine valworkcl
	
	
!______________________________________________________________________	

	subroutine valnonworkcl( stat, couple, valo, nodeas, nodebit)

	double precision estim1, estim4, intxet, intaet, valo
	integer couple, mina, node, nodeas, nodebit, stat



		call findcl(age, partcash, nodeas, mina, intaet, intxet, stat)
		node   = nodebit + mina  

		!visitnon(age,mina) = visitnon(age,mina) + 1
		
		
		estim1   = valuncl(node,age-ntmin)     
		estim4   = valuncl(node+1, age-ntmin)  
		valo	 = intaet*estim1 + intxet*estim4
		
	end subroutine valnonworkcl


!______________________________________________________________________	

	subroutine consumpt( stat, couple, cons, nodeas, nodebit)

	double precision cons, estim1, estim4, intxet, intaet
	integer couple, mina, node, nodeas, nodebit, stat


	
	if (stat.gt.0) then 
				  
		call find(age, partcash, nodeas, mina, intaet, intxet, stat)
		node   = nodebit + mina   

		visitemp(age,mina) = visitemp(age,mina) + 1
		
		estim1   = withemploy(node,age)     
		estim4   = withemploy(node+1, age)  
		cons	 = (intaet*estim1 + intxet*estim4)
 
	
	else

		call find(age, partcash, nodeas, mina, intaet, intxet, stat)
		node   = nodebit + mina  

		visitnon(age,mina) = visitnon(age,mina) + 1
		
		
		estim1   = withun(node,age)     
		estim4   = withun(node+1, age)  
		cons	 = intaet*estim1 + intxet*estim4
		



	endif

	end subroutine consumpt
	
	!______________________________________________________________________	

	subroutine consumptcl( stat, couple, cons, nodeas, nodebit)

	double precision cons, estim1, estim4, intxet, intaet
	integer couple, mina, node, nodeas, nodebit, stat


	
	if (stat.gt.0) then 
				  
		call findcl(age, partcash, nodeas, mina, intaet, intxet, stat)
		node   = nodebit + mina   

		visitemp(age,mina) = visitemp(age,mina) + 1
		
		estim1   = withemploycl(node,age-ntmin)     
		estim4   = withemploycl(node+1, age-ntmin)  
		cons	 = (intaet*estim1 + intxet*estim4)
 

	else

		call findcl(age, partcash, nodeas, mina, intaet, intxet, stat)
		node   = nodebit + mina   !if not working then alpha is irrelevant

		visitnon(age,mina) = visitnon(age,mina) + 1
		
		
		estim1   = withuncl(node,age-ntmin)     
		estim4   = withuncl(node+1, age-ntmin)  
		cons	 = intaet*estim1 + intxet*estim4
		


	endif

	end subroutine consumptcl


!______________________________________________________________________	

	subroutine consumptret( stat, couple, cons, nodeas, nodebit)

	double precision cons, estim1, estim4, intxet, intaet
	integer couple, mina, node, nodeas, nodebit, stat


	call find(age, partcash, nodeas, mina, intaet, intxet, stat)
	node   = nodebit + mina   !if not working then alpha is irrelevant
	


	visitnon(age,mina) = visitnon(age,mina) + 1
	
	if(couple.eq.1)then !couple
		estim1   = withr(node,age)     
		estim4   = withr(node+1, age)  
		cons	 = intaet*estim1 + intxet*estim4
	elseif(couple.eq.2)then  !widow-female
		estim1   = withrW(node,age)     
		estim4   = withrW(node+1, age)  
		cons	 = intaet*estim1 + intxet*estim4
	else     !widow-male
		estim1   = withrWh(node,age)     
		estim4   = withrWh(node+1, age)  
		cons	 = intaet*estim1 + intxet*estim4
	endif



	end subroutine consumptret



end module consolve

