subroutine partner(xx, ffxx, nxx)
use inputs
use params		!reads in parameters from params.inp
use wageproc	!defines the Markov process for primary and secondary earners using quadrature  
use assetgrid !defines bounds on the cash-in-hand dimension
use subrout   !transfers current state between routines (old common)
use equations !subroutines for solving optimisation step in recursion
!use reservat  !solving for reservation cash-in-hand (cash level above which choose not to work
use simulate  !for simulating the model once a solution is found
use banner
use statistics
use summaryindex
use makutility

implicit none

integer a, ier, ifail, i,j, nn,	node, nodebit,nodeas,  p, t, w, xm, pen, c, q, xtonon, xtoemp, ww, pp, &
    istart, iend, istart2, iend2, ri, wpen
	
integer:: nxx

double precision cons, connon, earnf, earnfnet, ediff,diff2, maxspd, minpt,&
resass,  value, valuenon, valnonold, leisemp, & 
valold, withemp, withnon, withnonold, total

double precision, allocatable :: asscut_tmp(:), valemp_tmp(:), withemp_tmp(:), leisemp_tmp(:), valun_tmp(:), withun_tmp(:),valo_tmp(:)
integer, allocatable :: dec_tmp(:), decsav_tmp(:), decemp_tmp(:)
double precision, allocatable :: asscut_tmptot(:), valemp_tmptot(:), withemp_tmptot(:), leisemp_tmptot(:), valun_tmptot(:), withun_tmptot(:),valo_tmptot(:)
integer, allocatable :: dec_tmptot(:), decsav_tmptot(:), decemp_tmptot(:)

double precision:: xx(nxx), ffxx(nxx)

INTEGER(2) hour, minute, second,hund

character(len=4)   :: cid


double precision:: minres,value2,withemp2,valuenon2,withnon2, check

 

if ( id .lt. 10 ) then
     write(cid,'(i1)') id
else if ( id .lt. 100 ) then
     write(cid,'(i2)') id
end if
     

!1-------------ALLOCATE MEMORY-----------------------------------------------------------------------------

if (firstcall.eq.1) then 

        call reading2( ier )
        if (ier.ne.0) then 
            write (*,*) 'trouble reading data in id ', ier, id
        endif

        call allocate_wageproc_perm(ier)
        if (ier.ne.0) then
	        write (*,*) 'trouble in allocating wage arrays in id ', ier, id
        endif

        call allocate_wageproc_temp(ier)
        if (ier.ne.0) then
	        write (*,*) 'trouble in allocating temp wage arrays in id ', ier, id
        endif

        call allocate_partproc_temp(ier)
        if (ier.ne.0) then
	        write (*,*) 'trouble in allocating temp partner arrays in id ', ier, id
        endif
        call allocate_simulate(ier)
        if (ier.ne.0) then
	        write (*,*) 'trouble inallocating simul arrays in id ', ier, id
        endif
        

       
endif

!2--------------OPEN FILES-----------------------------------------------------------------------------



if (id.eq.0) then 
    !open (unit=20, file ='../Outputs/sims.out')
	open (unit=21, file ='../Outputs/GridPointsVisited.out')

endif


!3-------------INITIALIZED VALUES---------------------------------------------------------------

!!!!!!!!!!!!!!!!parameters!!!!!!!!!!!!!!!!!!!
do i=1,npar
     modpars(i)  = xx(i) !grid search
enddo



chi        = modpars(1)  !no se usa

utpart3       = modpars(2)
utpart        = modpars(3)
utpart2       = modpars(4)


kidalpha0   = (1-quarter)*modpars(5) + quarter*0.25d0*modpars(5)
deltaper1   = (1-quarter)*modpars(6) + quarter*(1.d0 - (1.d0-modpars(6))**0.25d0)
iniggap     = modpars(7) 

bequest = modpars(10)
mu = modpars(11)

if (olive.eq.1) then 
    oleta1 = modpars(9)
    oleta0 = modpars(8)
    !!oleta0 = -oleta1*63.d0 + modpars(8)
    !modpars(7)      = -modpars(8)*63.d0 + exp(xx(7))                     
    alpha1 = 1.d0           ! is the default for no diminishing returns to human capital. 
elseif (olive.eq.0) then 
    oleta1 = 0.d0 
    alpha1 = modpars(9)       ! = 1.d0 is the default for no diminishing returns to human capital. 
    oleta0 = (1.d0 - alpha1) + modpars(8)
else 
    oleta1 = 0.d0 
    alpha1 = 1.d0 
endif




!!!!!!!!!!!variables!!!!!!!!!!!
begnosims = 1	 
weignosims = 0



totcon= 0.0d0 
toteis= 0.d0
totpay= 0.0d0 
totsav= 0.0d0
totfixed= 0.0d0
totpaypart= 0.0d0
varcon= 0.d0
varpay= 0.d0 
nonlin= 0.d0
partip= 0.d0
totexp= 0.d0
totexpun=0.d0
partnomot = 0.d0 
nomot = 0
wealth = 0.d0
growthY=0.d0
countpartY=0
growthO=0.d0
countpartO=0
totgappay = 0.d0 
totgappart = 0.d0
numsimsurv=0 
visitemp = 0
visitnon = 0
maxpartcash=-10000000.d0

!4------------SOLVING MODEL----------------------------------------------------------------
do ki=1,10

    !maternity type
	!cohort born in 1940s: average age at first= 22
    if(ki<=5)then
        agekid = -4   !young mothers
    else  
        agekid = 1    !old mothers
    endif
	
	if(ki==1.or.ki==6)ntH=37 !62
    if(ki==2.or.ki==7)ntH=38 !63
    if(ki==3.or.ki==8)ntH=39 !64
	if(ki==4.or.ki==9)ntH=40 !65
	if(ki==5.or.ki==10)ntH=41 !66
	
	    
    if(ki==1)then
        begnosims = 1  !adding number at j=1 to begin number
    else
        begnosims = 1 + int(sum(propkid(1:ki-1))*nosims)
    endif
    weignosims =  int(sum(propkid(1:ki))*nosims)	
  
	!begnosims  = 1
    !weignosims = nosims
	
if(ID==0)write(*,*)'ki',ki, begnosims, weignosims

call modpar
call markovwagepr
call gridpension
							 
do t=1,nt
	fixed(t) =  infants(t) 
enddo
		
call bounds



!set all solutions to wild	
valr			= -1.d100
valrW			= -1.d100
valrWh			= -1.d100
withr		= -1.d100
withrW		= -1.d100
withrWh		= -1.d100
valun		= -1.d100
withun		= -1.d100
valemploy	= -1.d100
withemploy  = -1.d100
asscut      = -1.d10
valuncl		= -1.d100
withuncl		= -1.d100
valemploycl	= -1.d100
withemploycl  = -1.d100
asscutcl      = -1.d10	

! loop backwards in time
!I-COMPULSORY RETIREMENT STAGE : FROM nt+1 TO nt+ret
do t=nt+ret,nt+1,-1
		
		if(ID==0)write(*,*)t

		age   = t
		ageto = age +1
		!xanon() is not contingent on states from t=nt+1 to nt+ret.All states share 
		!the same grid in the retirement period
        call gridret(1,1,age)

		ageret=t-nt
	    !couples
	        do p=1,pnw
	            pnode = p
	            do w=1,nw
				!w=1
				    wnodepen = w
				    do xm=1,nretage !noexp
						!xm=1
				        xvalue = xm
	                    !nodeas = sumindex(nmindex,(/w,p,xm/))

	                    do a=1,na
	    	                partcash = xaret(a,1,age)

					        call valret(valuenon,withnon)
					        !valnon solves for consumption (ie connon=withnon)
					        node = sumindex(nmindex2,(/w,p,xm,a/))
					  !~      valun(node, age)  = valuenon
					  !~      withun(node, age) = withnon
							valr(node, age)  = valuenon
					        withr(node, age) = withnon
							
						   			
	                    enddo
	                enddo
	           enddo
	        enddo

			!widows-females
	        do p=1,pnw
	            pnode = p
	            do w=1,nw			
				    wnodepen = w
				    do xm=1,nretage !noexp
						!xm=1
				        xvalue = xm
	                    !!!!nodeas = sumindex(nmindex,(/w,p,xm/))

	                    do a=1,na
	    	                partcash = xaret(a,1,age)
                            
					        call valretW(valuenon,withnon)
					        !valnon solves for consumption (ie connon=withnon)
					        node = sumindex(nmindex2,(/w,p,xm,a/))
					        valrW(node, age)  = valuenon
					        withrW(node, age) = withnon
                           				
	                    enddo
	                enddo
	           enddo
	        enddo
	
			!widows-males
			do p=1,pnw
	            pnode = p
	            !do w=1,nw
				w=1    !I assume males always get their own pension, so no need to keep track of female earnings
				    wnodepen = w
				    !do xm=1,noexp
						xm=1  
				        xvalue = xm
	                    !!!!nodeas = sumindex(nmindex,(/w,p,xm/))

	                    do a=1,na
	    	                partcash = xaret(a,1,age)
                            
					        call valretWh(valuenon,withnon)
					        !valnon solves for consumption (ie connon=withnon)
					        node = sumindex(nmindex2,(/w,p,xm,a/))
					        valrWh(node, age)  = valuenon
					        withrWh(node, age) = withnon
							
							
                           				
	                    enddo
	                !enddo
	           !enddo
	        enddo
		
			
enddo		!t=nt+ret,nt+1,-1	 


!II-BENEFICIARIES STAGE (FROM ntmin+1 TO nt) --- ALREADY CLAIMED

MPI_N = nonodescl2/nproc 
itemp = nonodescl2 - MPI_N*nproc
if (itemp>0) MPI_N=MPI_N+1	!!!!nonodes2 NOT equal to mpi_n*nproc if itemp>0
istart = id*MPI_N +1
iend = min((id+1)*MPI_N,nonodescl2)


MPI_N2 = nonodescl/nproc 
itemp = nonodescl - MPI_N2*nproc
if (itemp>0) MPI_N2=MPI_N2+1	!!!!nonodes NOT equal to mpi_n*nproc if itemp>0
istart2 = id*MPI_N2 +1
iend2 = min((id+1)*MPI_N2, nonodescl)


allocate (valemp_tmp(MPI_N2), withemp_tmp(MPI_N2), valun_tmp(MPI_N2), withun_tmp(MPI_N2) )
allocate(valun_tmptot(MPI_N2*NPROC), valemp_tmptot(MPI_N2*NPROC), withun_tmptot(MPI_N2*NPROC), withemp_tmptot(MPI_N2*NPROC) )

call MPI_Barrier(MPI_COMM_WORLD,ierr)

do t=nt,ntmin+1,-1   

	age   = t
	ageto = t+1
	if(ID==0)write(*,*)t
 
        !1-GRIDS
		!----------------------------------------------------------------------------------------------------------------------------
        do ri=1,nonodescl2
	        sindexcl = inv_sumindex(nmindexcl,ri)   
            
			wnode=sindexcl(1)
            pnode=sindexcl(2)
			xvalue = sindexcl(3) 
			wnodepen=sindexcl(4)
			cnode=sindexcl(5)
			qnode=sindexcl(6)
			
			!if(xvalue.le.t)then
			if(xvalue.le.t.AND.qnode.le.((t-ntmin)-clage+1))then  
			if(cnode.eq.1.OR.cnode.le.(t-ntH))then
			!solve only for feasible cases:
			!1-years of experience cannot be greater than age counter
			!2-number of years worked since claiming cannot be greater than number of periods since claimed
			!3-number of years worked since husband claimed cannot be greater than number of periods since husband claimed
            
			call gridcl(xvalue,ri,age-ntmin)
			!call gridnoncl(xvalue,ri,age-ntmin) 
			
			
            endif
			endif
        enddo
		!same grid for employed and unemployed
		xanoncl=xaworkcl
		
		!if(ID.eq.0)write(*,*)'grids done'
        call MPI_Barrier(MPI_COMM_WORLD,ierr) 

  
   
	!2-LOOP TO SOLVE AT EACH POINT OF THE STATE SPACE
	!----------------------------------------------------------------------------------------------------------------------------
	
    do ri=1,MPI_N2
            valemp_tmp(ri)  = -1.d10
            withemp_tmp(ri) = -1.d10
            valun_tmp(ri)   = -1.d10
            withun_tmp(ri)  = -1.d10
     enddo

        do ri=istart2,iend2


            sindexcl2 = inv_sumindex(nmindexcl2,ri)            

            w=sindexcl2(1)
            p=sindexcl2(2)
            xm = sindexcl2(3) 
			pen=sindexcl2(4)
			c=sindexcl2(5)
			q=sindexcl2(6)	
			a = sindexcl2(7)

			              
            wnode = w
            pnode = p
			xvalue = xm
			wnodepen=pen
			cnode=c
			qnode=q
			anode = a 
			
			!if(ID.eq.0)write(*,*)ri, w, p, xm, pen, c, q, a
			
			
			!wage      = xw(w,t) *  expvalue(xm,t) 
            wage   = xw(w,t) * ryearsexp(expvalue(xm,t))

		   

			if(t.lt.nt)then
				xtoemp = max(mapping( t,xm, 1),1) !assume min hours to define minincome
				xtonon = max(mapping( t,xm, 0),1)
			else
				xtoemp = 1
				xtonon = 1
			endif

            
			
		    nodeas = sumindex(nmindexcl,(/w,p,xm,pen,c,q/))

            !state variable for cash-in-hand if working

	        node		= ri 
			
	        partcash	= xaworkcl(a,nodeas, age-ntmin) 
			
			
			!pensionf,part,taxhusband are needed to calculate the earnings test and the hhold taxes if women works
			
			if(age.gt.ntH)then
				pensionf=max(pxpen(pnode)*ssif(nssif),xpenlong(wnode,xvalue,qnode,t))
			else
				pensionf=xpenlong(wnode,xvalue,qnode,t)
			endif

			if(t.le.ntH)then !1-payroll tax only on earnings,2-we assume soc sec benefits do not pay federal tax
				part=pxw(p,t) 
				taxhusband=federaltaxm(part,pensionf)

			else
				part = pxw(p,t) 
				taxhusband=federaltaxm(part,pensionf)
			endif
			

			!2.1--VALUE FUNCTION OF EMPLOYED 
			if(xvalue.le.t.AND.qnode.le.((t-ntmin)-clage+1))then   
			if(cnode.eq.1.OR.cnode.le.(t-ntH))then
			!solve only for feasible cases:
			!1-years of experience cannot be greater than age counter
			!2-number of years worked since claiming cannot be greater than number of periods since claimed
			!3-number of years worked since husband claimed cannot be greater than number of periods since husband claimed
			earnf=wage*hoursfix
			earnfnet=earnf-payrolltax(earnf)
			if (partcash +earnfnet -federaltax(part,earnf,taxhusband,pensionf) - fixed(age) - min(max((earnf-earntest)*0.5d0,0.d0),pensionf).gt.0.d0) then
						
						call valempcl(value,withemp,leisemp)  
	
						valemp_tmp(ri-istart2+1)  = value
						withemp_tmp(ri-istart2+1) = withemp		

					
			endif 			
			endif  
			endif
			
		    !2.2--VALUE FUNCTION OF UNEMPLOYED
		    if(xvalue.le.t.AND.qnode.le.((t-ntmin)-clage+1))then  
			if(cnode.eq.1.OR.cnode.le.(t-ntH))then
			!solve only for feasible cases:
			!1-years of experience cannot be greater than age counter
			!2-number of years worked since claiming cannot be greater than number of periods since claimed
			!3-number of years worked since husband claimed cannot be greater than number of periods since husband claimed
			
						
				partcash = xanoncl(a,nodeas, age-ntmin) 

				if (partcash+mininc(xtonon,age).lt.-1.d-8) then !not work gives neg consumption

						write (*,*) 'problem in non solution ',ID
							
				elseif (partcash+mininc(xtonon,age).ge.0.d0) then
						
						call valnoncl(valuenon,withnon)
								  							
						valun_tmp(ri-istart2+1)  = valuenon
						withun_tmp(ri-istart2+1) = withnon
				
				endif

			endif
			endif


    enddo !end of ri loop

  
	!save 

    valun_tmptot=-1.d100
    call MPI_Barrier(MPI_COMM_WORLD,ierr)
    call MPI_AllGATHER(valun_tmp(1),MPI_N2,MPI_DOUBLE_PRECISION,valun_tmptot(1),MPI_N2,MPI_DOUBLE_PRECISION, MPI_COMM_WORLD, ierr ) 
    do ri=1,nonodescl
	    valuncl(ri,age-ntmin)=valun_tmptot(ri)
		
    enddo

    withun_tmptot=-1.d100
    call MPI_Barrier(MPI_COMM_WORLD,ierr)
    call MPI_AllGATHER(withun_tmp(1),MPI_N2,MPI_DOUBLE_PRECISION,withun_tmptot(1),MPI_N2,MPI_DOUBLE_PRECISION, MPI_COMM_WORLD, ierr ) 
    do ri=1,nonodescl
	    withuncl(ri,age-ntmin)=withun_tmptot(ri)
    enddo

    valemp_tmptot = -1.d100
    call MPI_Barrier(MPI_COMM_WORLD,ierr)
    call MPI_AllGATHER(valemp_tmp(1),MPI_N2,MPI_DOUBLE_PRECISION,valemp_tmptot(1),MPI_N2,MPI_DOUBLE_PRECISION, MPI_COMM_WORLD, ierr ) 
    do ri=1,nonodescl
	    valemploycl(ri,age-ntmin)=valemp_tmptot(ri)
		
    enddo

    withemp_tmptot=-1.d100
    call MPI_Barrier(MPI_COMM_WORLD,ierr)
    call MPI_AllGATHER(withemp_tmp(1),MPI_N2,MPI_DOUBLE_PRECISION,withemp_tmptot(1),MPI_N2,MPI_DOUBLE_PRECISION, MPI_COMM_WORLD, ierr ) 
    do ri=1,nonodescl
	    withemploycl(ri,age-ntmin)=withemp_tmptot(ri)
    enddo


    call MPI_Barrier(MPI_COMM_WORLD,ierr)

	
enddo !end loop on age, backwards


deallocate (valemp_tmp, withemp_tmp, valun_tmp, withun_tmp )
deallocate(valun_tmptot, valemp_tmptot, withun_tmptot , withemp_tmptot)

!III-NON-PENSION ELIGIBLE STAGE (FROM 1 TO ntmin) 


MPI_N = nonodes2/nproc 
itemp = nonodes2 - MPI_N*nproc
if (itemp>0) MPI_N=MPI_N+1	!!!!nonodes2 NOT equal to mpi_n*nproc if itemp>0
istart = id*MPI_N +1
iend = min((id+1)*MPI_N,nonodes2)


MPI_N2 = nonodes/nproc 
itemp = nonodes - MPI_N2*nproc
if (itemp>0) MPI_N2=MPI_N2+1	!!!!nonodes NOT equal to mpi_n*nproc if itemp>0
istart2 = id*MPI_N2 +1
iend2 = min((id+1)*MPI_N2, nonodes)



allocate (valemp_tmp(MPI_N2), withemp_tmp(MPI_N2), valun_tmp(MPI_N2), withun_tmp(MPI_N2) )
allocate(valun_tmptot(MPI_N2*NPROC), valemp_tmptot(MPI_N2*NPROC),  withemp_tmptot(MPI_N2*NPROC), withun_tmptot(MPI_N2*NPROC) )


do t=ntmin,1,-1   

	age   = t
	ageto = t+1
	if(ID==0)write(*,*)t
       
        !1-GRIDS
		!----------------------------------------------------------------------------------------------------------------------------
        do ri=1,nonodes2
	        sindex = inv_sumindex(nmindex,ri)   
            xvalue = sindex(3) 
			if(xvalue.le.t)then
            
			call grid(xvalue,ri,age)	
			!call gridnon(xvalue,ri,age) 
            endif
        enddo
		!same grid for employed and unemployed
		xanon=xawork
   
        call MPI_Barrier(MPI_COMM_WORLD,ierr) 
  
   
	!2-LOOP TO SOLVE AT EACH POINT OF THE STATE SPACE
	!----------------------------------------------------------------------------------------------------------------------------
	
	solutiongrid=1
	
	
    do ri=1,MPI_N2
            valemp_tmp(ri)  = -1.d10
            withemp_tmp(ri) = -1.d10
            valun_tmp(ri)   = -1.d10
            withun_tmp(ri)  = -1.d10
     enddo

        do ri=istart2,iend2


            sindex2 = inv_sumindex(nmindex2,ri)            

            w=sindex2(1)
            p=sindex2(2)
            xm = sindex2(3) 
            a = sindex2(4)

			anode = a               
            wnode = w
            pnode = p
            !part = pxw(p,t)

		    xvalue = xm

			if(t.lt.nt)then
				xtoemp = max(mapping( t,xm, 1),1) !assume min hours to define minincome
				xtonon = max(mapping( t,xm, 0),1)
			else
				xtoemp = 1
				xtonon = 1
			endif

			
			
		    nodeas = sumindex(nmindex,(/w,p,xm/))

            !state variable for cash-in-hand if working

	        node		= ri 
	        partcash	= xawork(a,nodeas, age) 
			
			
			!part,taxhusband are needed to calculate the hhold taxes if women works
			
			part=pxw(p,t) 
			taxhusband=federaltaxm(part,0.d0)
            !wage      = xw(w,t) *  expvalue(xm,t) 
            wage   = xw(w,t) * ryearsexp(expvalue(xm,t))
			
			

			!2.1--VALUE FUNCTION OF EMPLOYED 
			if(xm.le.t)then   !solve only for realistic cases: note that years of experience cannot be greater than age counter
					
				!earnf=wage*hoursfix-payrolltax(earnf)		
				earnf=wage*hoursfix
			    earnfnet=earnf-payrolltax(earnf)
				if (partcash + earnfnet- federaltax(part,earnf,taxhusband,0.d0) - fixed(age).gt.0.d0) then

						call valemp(value,withemp,leisemp)  !this solves for the optimal value function
						
															!at this point in the state space
						
						valemp_tmp(ri-istart2+1)  = value
						withemp_tmp(ri-istart2+1) = withemp
						
	
														
				endif 			
			endif  !xm.lt.t
			
		    !2.2--VALUE FUNCTION OF UNEMPLOYED
		    if(xm.le.t)then   !solve only for realistic cases: note that years of experience cannot be greater than age counter
				
						
						partcash = xanon(a,nodeas, age)

						if (partcash.lt.-1.d-8) then !not work gives neg consumption

							write (*,*) 'problem in non solution ',ID
							

						elseif (partcash+mininc(xtonon,age).ge.0.d0) then
						
							
								call valnon(valuenon,withnon)
								  
														
								valun_tmp(ri-istart2+1)  = valuenon
								withun_tmp(ri-istart2+1) = withnon
								
						endif

			endif


    enddo !end of ri loop

    
  
	!save 

    valun_tmptot=-1.d100
    call MPI_Barrier(MPI_COMM_WORLD,ierr)
    call MPI_AllGATHER(valun_tmp(1),MPI_N2,MPI_DOUBLE_PRECISION,valun_tmptot(1),MPI_N2,MPI_DOUBLE_PRECISION, MPI_COMM_WORLD, ierr ) 
    do ri=1,nonodes
	    valun(ri,age)=valun_tmptot(ri)
    enddo

    withun_tmptot=-1.d100
    call MPI_Barrier(MPI_COMM_WORLD,ierr)
    call MPI_AllGATHER(withun_tmp(1),MPI_N2,MPI_DOUBLE_PRECISION,withun_tmptot(1),MPI_N2,MPI_DOUBLE_PRECISION, MPI_COMM_WORLD, ierr ) 
    do ri=1,nonodes
	    withun(ri,age)=withun_tmptot(ri)
    enddo

    valemp_tmptot = -1.d100
    call MPI_Barrier(MPI_COMM_WORLD,ierr)
    call MPI_AllGATHER(valemp_tmp(1),MPI_N2,MPI_DOUBLE_PRECISION,valemp_tmptot(1),MPI_N2,MPI_DOUBLE_PRECISION, MPI_COMM_WORLD, ierr ) 
    do ri=1,nonodes
	    valemploy(ri,age)=valemp_tmptot(ri)
    enddo

    withemp_tmptot=-1.d100
    call MPI_Barrier(MPI_COMM_WORLD,ierr)
    call MPI_AllGATHER(withemp_tmp(1),MPI_N2,MPI_DOUBLE_PRECISION,withemp_tmptot(1),MPI_N2,MPI_DOUBLE_PRECISION, MPI_COMM_WORLD, ierr ) 
    do ri=1,nonodes
	    withemploy(ri,age)=withemp_tmptot(ri)
		
    enddo


    call MPI_Barrier(MPI_COMM_WORLD,ierr)

	
enddo !end loop on age, backwards


deallocate (valemp_tmp, withemp_tmp, valun_tmp, withun_tmp )
deallocate(valun_tmptot, valemp_tmptot, withemp_tmptot, withun_tmptot)


solutiongrid=2
!5---------------SIMULATE-----------------------------------------------------------------------
call empsim				 !simulation routine once the numerical solution is found



enddo !end of loop over ki




!6---------------STATISTICS-----------------------------------------------------------------------
call simulstats



!calibration error!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
do j=1,npar
    ffxx(j) = calibstats(j)
enddo
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


666  continue

9999 format (5(3x,e14.6))
9998 format (5(2x,e14.6))

7888 format (e14.6)
8888 format (E14.6, 2(2x,I4), 3(3x,e14.6))
8887 format ( 3(I6,2X), e16.6 )   

RETURN


900 continue

end subroutine partner



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
