clear
capture log close


log using sampleMERGE-R1.log,replace
u sample

rename stat statB
rename couple coupleB
rename retage retageB
rename experien experienB
rename saving savingB
rename partcash partchasB
rename wagef wagefB
rename piaf piafB 
rename socsecf socsecfB
rename penf penfB
rename tipoMARR tipoMARRB

*this allocates the type of beneficiary woman will be
by i:egen typeMARRB=min(tipoMARRB)


*there are some women who die in t=42 and then tipoMARR is not reported for them
drop if typeMARRB==1000


gen typeMARRB2=1 if typeMARRB==1
replace typeMARRB2=2 if typeMARRB==2 | typeMARRB==3

merge 1:1 i t using sampleR1

keep if age<=65


latabstat statB stat, f(%5.2f)


gen     g=1 if age>=25 & age<=29
replace g=2 if age>=30 & age<=34
replace g=3 if age>=35 & age<=39
replace g=4 if age>=40 & age<=44
replace g=5 if age>=45 & age<=49
replace g=6 if age>=50 & age<=54
replace g=7 if age>=55 & age<=59
replace g=8 if age>=60 & age<=65

table g if typeMARRB==1,c(mean statB mean stat mean experienB mean experien)
latabstat statB stat  if typeMARRB==1, by(g ) nototal f(%5.2f)

table g if typeMARRB==2 | typeMARRB==3,c(mean statB mean stat mean experienB mean experien)
latabstat statB stat  if typeMARRB==2 | typeMARRB==3, by(g ) nototal f(%5.2f)



latabstat statB stat, by(typeMARRB2) nototal f(%5.2f)

/*
COMMENTS:
1-women who were eligible as workers in the baseline have almost same participation profile. It is only slighly above what
is related with the uncertainty in labor earnings

2-women who were eligible as workers+spousal or spousal in the baseline increase their participation substaintially.
In particular we observe they increase their participation in order to qualify for a public pension, so that they complete
the 10 years of work experience that are required. Maybe the effects would be smoother if there was a pure proportional 
benefit.


*/


*by first child arrival age

table g if agekid==-4,c(mean statB mean stat mean experienB mean experien)
latabstat statB stat  if agekid==-4, by(g ) nototal f(%5.2f)

table g if agekid==1,c(mean statB mean stat mean experienB mean experien)
latabstat statB stat  if agekid==1, by(g ) nototal f(%5.2f)

latabstat statB stat, by(agekid) nototal f(%5.2f)


**by husband retirement age

table g if ntH<39,c(mean statB mean stat mean experienB mean experien)
latabstat statB stat  if ntH<39, by(g ) nototal f(%5.2f)


table g if ntH>=39,c(mean statB mean stat mean experienB mean experien)
latabstat statB stat  if ntH>=39, by(g ) nototal f(%5.2f)



latabstat statB stat, by(ntH) nototal f(%5.2f)


log close


*fin