module simulate

!simulation routine using the numerical solution

use params
use wageproc
use assetgrid
use subrout
use consolve
use inputs
use equations

implicit none   
      
double precision, private:: assterm, cons, conse,consu, dum, earnf, earnfnet, experien, highun, hourswork, it1, it2, leis, logcon, &
	  logpay, lowun, ocons, oleis,oldcon, owage,probhigh, rannum, saving, socsec, val, within, p1,p2,p3, taxm, taxf, taxwife, &
& piaf, penf, socsecm, socsecf, valtoe, valtou

double precision logpart, mult,  totgappart, partkidtmp, partkidtmp2,partkidtmp3, growthO, growthY
   
double precision, allocatable :: avpart(:), nonlin(:)  
double precision, allocatable :: totcon(:), toteis(:), totexp(:)
double precision, allocatable :: totgappay(:),totpay(:),totwage(:), totsav(:), varcon(:), varpay(:) ,  varpart(:) ,totexpun(:) 
double precision, allocatable :: totfixed(:), totpaypart(:),  wealth(:)



integer, private:: a, bit, couple, dumi, expval, expto, exptoold, expcond, i, ifail, &
				j, jl, jm, ju, node, nodebit, nodeas, nodeas2,  offeralpha, ocouple, p, s, seed, stat, t, &
				nodebit2, tipoMARR, trwnode2, ptrnode, tt, ttt, w,  xmin, z, nextage, retage, qto, cto

integer, allocatable:: 	partip(:), yearswork(:,:)

double precision:: uc, euler

integer::agechild1, agechild2, aux2,aux3,nomot,  jj, yrsexp, countpartO, countpartY



   

contains 

subroutine allocate_simulate( iret  )
		implicit none
		integer, intent(out)	:: iret
		integer								:: ier(2) 

		allocate (avpart(totlen), nonlin(totlen),  &
			totcon(totlen), toteis(totlen), totexp(totlen), totexpun(totlen), totfixed(totlen), totgappay(totlen),&
			totpaypart(totlen), totpay(totlen), totwage(totlen), totsav(totlen), varcon(totlen), varpay(totlen), varpart(totlen), & 
			wealth(totlen),stat=ier(1) )

		allocate ( partip(nt), yearswork(nosims,totlen), stat=ier(2) )

		do i=1,2
			if ( ier(i) .ne. 0) then 
				iret = -i
				return
			endif
		enddo

		iret = 0   

end subroutine allocate_simulate
!_______________________________________________________________________
subroutine empsim
     
	
	lowun = 0.d0
	highun = 1.d0


   !call init_random_seed(123457)
  
	
	if(ID.eq.0)write(*,*)begnosims,weignosims
	
		do i = begnosims,weignosims

		  bit = (i-1)*nt


		  yrsexp = 0
			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			!WORKING LIFE
			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			wnodepen=1
			cnode=1 
			qnode=1
			qto=1
			cto=1
			piaf=0.d0
			
			
			do t = 1,nt

				age = t
				ageto = t+1

				retage= 0 ! this is a dummy that would take value 1 from the first period of retirement
				node = bit + t
				
				year=(t-1)/4 + 1
				
				couple=1
				
				!1--------------------------find current state

				if (age.eq.1) then  
					! find INITIAL permanent wage
					if(nw.gt.1.and.pnw.gt.1)then
					    do j=1,nw
					      do p=1,pnw
						    if (randnos1(node).le.contot(j,p,1,1,age)) then
							    wnode    = j
							    pnode    = p
							    goto 10077
						    endif
                          enddo
					    enddo
					else
					    wnode=1
					    pnode=1
					endif
					
					!write (10,*) 'problem, transit(w,wnode) ',contot(nw,pnw,wnode,pnode,age), randnos1(node)
10077				continue

					expval    = 1 !noexp
				    experien  = expvalue(expval,t)
					!wage    = xw(wnode,t) *  experien 
					wage   = xw(wnode,t) * ryearsexp(experien) 
					part    = pxw(pnode,t)  
					asset   = 0.001d0
				
		
				else

					asset = saving * detrr
                    
                    
					! find new permanent wage and permanent earnings
					if(pnw.gt.1.and.nw.gt.1)then
					        !if(quarter.eq.0)then
					            do j=1,nw
					            do p=1,pnw  
						            if (randnos1(node).le.contot(j,p,wnode,pnode,age)) then
    							        
									    wnode    = j
									    pnode	 = p
										
							            goto 77
						            endif
			                    enddo
					            enddo

					   else
					        wnode=1
					        pnode=1
					   
					   endif !nw,pnw>1
					        
77      			   continue


					
					
						
					!wage depends on experience: so weighted average of high and low experience
					if(noexp.ge.2)then
						if (experien.le.expvalue(1,age)) then 
							
							probhigh = 0.d0	  !this is a weighting in a linear interpolation
							expval   = 1
						
						elseif (experien.ge.expvalue(min(t,noexp),age).or.expto.eq.min(t,noexp)) then 
							
							probhigh = 1.d0
							expval   = min(t,noexp)
						
						elseif (expto.lt.min(t,noexp)) then
							
							probhigh = 1.d0 - (expvalue(expto+1,age) - experien) / & 
								(expvalue(expto+1,age) - expvalue(expto,age) ) 

							if (randexp(node).le.probhigh) then
								expval = expto + 1
							else
								expval = expto
							endif						

						endif
						!wage     = xw(wnode,t) * expvalue(expval,t) 
						wage   = xw(wnode,t) * ryearsexp(expvalue(expval,t))

						
					else
						wage     = xw(wnode,t) 
						expval=1
					endif
					exptoold=expto
					 
																				   				

				endif
				
				
				earnf=wage*hoursfix
				taxf=payrolltax(earnf)
				earnfnet=earnf -taxf
				
				xvalue=expval
				qnode=qto
				cnode=cto
				if(age.le.ntH)then
					part = pxw(pnode,t)  
					taxm = payrolltax(part) 
					
					!!!taxhusband =  federaltaxm(part)
					socsecm=0.d0
				else
					part=pxpen(pnode)
					taxm = 0.d0 
					!!!taxhusband =  0.d0
					socsecm=pxpen(pnode)
				endif
				
				if(age.le.ntmin)then
					socsecf=0.d0
					penf=0.d0
				else
					penf=xpenlong(wnode,xvalue,qnode,t)
					piaf=pialong(wnode,xvalue,qnode,t)
					socsecf=max(socsecm*ssif(nssif),penf)
						
				endif
				
				
				taxhusband =  federaltaxm(part,socsecf)
				
				
				partcash = asset + part - taxm	-taxhusband + socsecf

				visitexpvalue(age,xvalue)=visitexpvalue(age,xvalue) + 1

				!2---------------------------find optimal decisions
		
                if(t.le.ntmin)then
					nodeas2  = (wnode-1)*pnw*noexp + (pnode-1)*noexp + expval
					nodebit2 = (wnode-1)*pnw*na*noexp + (pnode-1)*na*noexp + (expval-1)*na
					
					
					!if (asscut(nodeas2,age).lt.partcash) then !not working
						!value of non-working
						stat     = 0
						call consumpt( stat, couple, consu, nodeas2, nodebit2)
						call valnonwork( stat, couple, valtou, nodeas2, nodebit2)

						
			
						!if(partcash>maxpartcash(t))maxpartcash(t)=partcash

					!else !working
						!value of working
						if((partcash + earnfnet- federaltax(part,earnf,taxhusband,socsecf) - fixed(age)).gt.0.d0)then
							stat = 1
							call consumpt( stat, couple, conse, nodeas2, nodebit2)		
							call valwork( stat, couple, valtoe, nodeas2, nodebit2)
						else
							valtoe = -1.d10
						endif
						
						
						
						
					!endif
					!working decision
					if(valtou.gt.valtoe)then !non-working
						stat=0
						cons=consu
						experien = expvalue(expval,t) * (1.d0 - deltaperF(expvalue(expval,t)))
						
						if(t.lt.nt.and.noexp.ge.2)then
							expto = max(mapping(t,expval,0),1)
						else
							expto = expval !1
						endif
						
						taxf     = 0.d0
						taxwife = 0.d0
						saving = partcash -cons
						leis = hours
					
					
					else
						stat=1
						cons=conse
						experien = humancap(t,expvalue(expval,t) )  !experience tomorrow, continous
						yrsexp = yrsexp + 1
						
						if(t.lt.nt.and.noexp.ge.2)then
							expto = max(mapping(t,expval,1),1)  !experience tomorrow, discrete
						else
							expto = expval !1
						endif
						
						
						!taxwife = federaltax(part-taxm,earnf,taxhusband)
						taxwife = federaltax(part,earnf,taxhusband,socsecf)
						saving	= partcash + earnfnet -taxwife - fixed(t) - cons
						leis=hourseis
					
					endif
					
					
				else
					nodeas2  = (wnode-1)*pnw*noexp*1*nq2*nq + (pnode-1)*noexp*1*nq2*nq + (expval-1)*1*nq2*nq + (wnodepen-1)*nq2*nq  + (cnode-1)*nq + qnode 
					nodebit2 = (wnode-1)*pnw*na*noexp*1*nq2*nq + (pnode-1)*na*noexp*1*nq2*nq + (expval-1)*na*1*nq2*nq + (wnodepen-1)*na*nq2*nq  + (cnode-1)*na*nq + (qnode-1)*na
					
					
					!if (asscutcl(nodeas2,age-ntmin).lt.partcash) then !not working
						!value of non woking
						stat     = 0			
						call consumptcl( stat, couple, consu, nodeas2, nodebit2)
						call valnonworkcl( stat, couple, valtou, nodeas2, nodebit2)	
						!if(partcash>maxpartcash(t))maxpartcash(t)=partcash

					!else !working
						!value of working
						if((partcash + earnfnet - federaltax(part,earnf,taxhusband,socsecf) - fixed(age) - min(max((earnf-earntest)*0.5d0,0.d0),socsecf)).gt.0.d0)then
							stat = 1
							call consumptcl( stat, couple, conse, nodeas2, nodebit2)	
							call valworkcl( stat, couple, valtoe, nodeas2, nodebit2)	
						else
							valtoe = -1.d10
						endif
						
						
						
					!endif
					!working decision
					if(valtou.gt.valtoe)then !non-working
						stat=0
						cons=consu
						experien = expvalue(expval,t) * (1.d0 - deltaperF(expvalue(expval,t)))
						
						if(t.lt.nt.and.noexp.ge.2)then
							expto = max(mapping(t,expval,0),1)
						else
							expto = expval !1
						endif
						
						taxf     = 0.d0
						taxwife = 0.d0
						saving = partcash -cons
						leis = hours
					
					else
				
						stat=1
						cons=conse
						experien = humancap(t,expvalue(expval,t) )  !experience tomorrow, continous
						yrsexp = yrsexp + 1
						
						if(t.lt.nt.and.noexp.ge.2)then
							expto = max(mapping(t,expval,1),1)  !experience tomorrow, discrete
						else
							expto = expval !1
						endif
			

						!taxwife=federaltax(part-taxm,earnf,taxhusband)
						taxwife=federaltax(part,earnf,taxhusband,socsecf)
						saving	= partcash + earnfnet -taxwife - fixed(t) -min(max((earnf-earntest)*0.5d0,0.d0),socsecf) - cons
						leis = hourseis
						
						if(t.lt.nt)qto= qnode + 1 !only update in periods before t=nt, because of the structure of pensionfnt()
						if(t.lt.nt.AND.t.ge.(ntH+1))cto= cnode + 1 !only update in periods before t=nt, because of the structure of pensionfnt()
						
		
					
					
					endif
					
					
				endif
				
			
				hourswork=hours - leis
				yearswork(i,t) = yrsexp

                if(ID==0.and.cons<0.d0)write(*,*)'neg cons simu',t,partcash,asset,stat

                

			
				!3----------------------------------variables to build several statistics
				
				logcon       = log(cons)
				logpart      = log(part)
				
				if (stat.gt.0) logpay = log(wage*hoursfix)
				
				if (stat.gt.0) toteis(t) = toteis(t) + hoursfix
			  
				totcon(t)	 = totcon(t) + logcon
				varcon(t)	 = varcon(t) + logcon*logcon
				totfixed(t)	 = totfixed(t) + fixed(t)
				totsav(t)    = totsav(t) + saving			
				totpaypart(t)= totpaypart(t) + pxw(pnode,t)  
				varpart(t)   = varpart(t) + logpart*logpart
				
				wealth(t)    = wealth(t) + asset

				if (t.le.ntH) totgappart = totgappart + pxw(pnode,t)/phoursfix

				!--------------------------------------------------------------------------------------------------
				if(couple.eq.1)then
					uc=margutc(cons,leis,t,1)
				else
					uc=margutc(cons,leis,t,2)
				endif
              
                
				if (t.ge.2) then 
				    if(couple.eq.1)then
						euler=uc/margutc(ocons,oleis,t-1,1)
					else
						euler=uc/margutc(ocons,oleis,t-1,2) !en realidad no hay nadie aqui hasta la jubilacin
					endif
					nonlin(t) = nonlin(t) + euler
				endif
				
				
				
				
				if(id==0.and.t.le.ntH)then
					write(44,'(1i4,1x,7i3,3i5,1x,17f14.2)')i,t,yrsexp,stat,couple,retage,qnode,cnode,agekid,ntH,1000,&
				&expvalue(expval,t),asset,pxw(pnode,t),partcash,wage,cons,&
				&socsecm,piaf,socsecf,penf,euler,taxm,taxf,taxhusband,taxwife,fixed(t) 
				
				
				
				elseif(id==0.and.t.gt.ntH)then
					write(44,'(1i4,1x,7i3,3i5,1x,17f14.2)')i,t,yrsexp,stat,couple,retage,qnode,cnode,agekid,ntH,1000,&
				&expvalue(expval,t),asset,0.d0,partcash,wage,cons,&
				&socsecm,piaf,socsecf,penf,euler,taxm,taxf,taxhusband,taxwife,fixed(t) 

				
				endif
			
	            
	
				totwage(t) = totwage(t) + log(wage)
				if (stat.gt.0) then 		
	
					partip(t) = partip(t) + 1
				
					totpay(t) = totpay(t) + logpay
					!totwage(t) = totwage(t) + log(wage)
					if (t.le.ntH) totgappay(t) = totgappay(t) + wage !*hoursfix

					varpay(t) = varpay(t) + logpay*logpay
					

					totexp(t) = totexp(t) + expvalue(expval,t)
					
					
					if(t.ge.2.AND.t.le.11)then
						if(leis.lt.hours.AND.oleis.lt.hours)then
							countpartY = countpartY + 1                
							growthY = growthY + wage/owage-1.d0                 
						endif
					endif
					if(t.ge.12.AND.t.le.26)then
						if(leis.lt.hours.AND.oleis.lt.hours)then
							countpartO= countpartO + 1                
							growthO = growthO + wage/owage-1.d0                 
						endif
					endif
			  
			 
				else

				     totexpun(t) = totexpun(t) + expvalue(expval,t)
				
				endif

				oldcon = logcon
				ocons  = cons
				oleis  = leis
				owage=wage

			
			enddo  !end of working time
			
			
			
			
			
			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			!RETIREMENT LIFE
			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
					
			assterm = saving * detrr
			leis = hours
			taxhusband=0.d0
			taxwife=0.d0
			
			couple=1
			
			socsecm = pxpen(pnode) 
			
			call pensionfnt(xw(wnode,age),xvalue,pnode,qnode,cnode,stat,wnodepen,socsecf,tipoMARR)
						
			xvalue = clage
			
			!socsecf=max(socsecm*ssif(nssif),xpen(wnodepen))
			penf=xpen(wnodepen)
			socsecf=penf !already found the maximum between the spousal and the own-pension: the socsecf that outputs pensionfnt is the true one, but we need the actual one (the approximation)

			
			do t=nt+1,nt+ret
			
			    node = (i-1)*ret + t 
					
				age = t
				stat=0
				totpaypart(t)= totpaypart(t) + pxpen(pnode)  
			
				if(t.ge.nt+1)then
					p1=pdeath1(t-nt)*pdeath2(t-nt)
					p2=pdeath1(t-nt)*psurv2(t-nt)	+ p1
					p3=pdeath2(t-nt)*psurv1(t-nt) + p1 + p2
				
				else
					p1=0.d0
					p2=0.d0
					p3=0.d0
				endif
				

				!we only have to recalculate household pension when husband or wife passes away

				!husband and/or wife may pass away at the beginning of the period
				if(couple.eq.1)then
					if(randupdate(node).le.p1)then !both die
						cons=0.d0
						couple=9
						exit
					elseif(randupdate(node).gt.p1.AND.randupdate(node).le.p2)then !only husband dies
						couple=2
						socsecf	= max(socsecm*survpen(xvalue),xpen(wnodepen))
						socsecm = 0.d0
						
						!nodeas2  = (wnode-1)*pnw*noexp + (pnode-1)*noexp + expval
						!we do not use nodea2 becasue xanon() is not contingent on states from t=nt+1 to nt+ret
						nodebit2 = (wnodepen - 1)*pnw*na*noexp  + (pnode-1)*na*noexp + (xvalue-1)*na

					elseif(randupdate(node).gt.p2.AND.randupdate(node).le.p3)then !only wife dies
						couple=3
						socsecf = 0.d0
						!nodeas2  = (wnode-1)*pnw*noexp + (pnode-1)*noexp + expval
						!we do not use nodea2 becasue xanon() is not contingent on states from t=nt+1 to nt+ret
						nodebit2 = (1 - 1)*pnw*na*noexp  + (pnode-1)*na*noexp + (1-1)*na
			
				
					else !nobody dies
						nodebit2 = (wnodepen-1)*pnw*na*noexp + (pnode-1)*na*noexp + (xvalue-1)*na
					
					endif
				elseif(couple.eq.2)then
					if(randupdate(node).le.pdeath2(t-nt))then !widow-female dies
						cons=0
						couple=9
						exit
					endif
				elseif(couple.eq.3)then
					if(randupdate(node).le.pdeath1(t-nt))then !widow-male dies
						cons=0
						couple=9
						exit
					endif
				
				endif
				
				socsec = socsecf + socsecm 
				
				
				taxhusband =  federaltaxm(socsecm,socsecf)
				taxwife=0.d0
				
				partcash = assterm + socsec	-taxhusband

				!if(t.lt.ret)then		
				call consumptret( 2, couple, cons, 1, nodebit2)
				!else  !NOW THERE ARE BEQUEST, SO THEY DO NOT CONSUME ALL CASH
				!    cons=partcash
				!endif

				
				wealth(age)    = wealth(age) + assterm 	
				saving = partcash - cons
				leis = hours
				
				
				if(partcash>maxpartcash(t))maxpartcash(t)=partcash			
				
				logcon = log(cons)			  
				totcon(t) = totcon(t) + logcon
				
				if(t.gt.nt)numsimsurv(t-nt)=numsimsurv(t-nt) + 1
				!nonlin(nt+t) = nonlin(nt+t) + margutc(cons,leis,nt+t)/margutc(ocons,oleis,nt+t-1)
				
				 if(couple.eq.1)then
					euler=margutc(cons,leis,t,1)/margutc(ocons,oleis,t-1,1)
					nonlin(t) = nonlin(t) + euler
				else
					if(ocouple.eq.1)then
						euler=margutc(cons,leis,t,2)/margutc(ocons,oleis,t-1,1)
					else
						euler=margutc(cons,leis,t,2)/margutc(ocons,oleis,t-1,2)
					endif
					nonlin(t) = nonlin(t) + euler
				endif
					
				
				totsav(t) = totsav(t) + saving
				
				if(id==0)write(44,'(1i4,1x,7i3,3i5,1x,17f14.2)')i,t,yrsexp,0,couple,retage,qnode,cnode,agekid,ntH,tipoMARR,&
					&expvalue(expval,nt),assterm,0.d0,partcash,0.d0,cons,&
					&socsecm,piaf,socsecf,penf,euler,0.d0,0.d0,taxhusband,taxwife,0.d0
				


				ocons = cons
				oleis = hours
				ocouple=couple
				
				
				
				assterm = detrr * saving 

					

				enddo
		


		enddo !end weignosims , end individual i 

end subroutine empsim

end module simulate

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
