subroutine partner(xx, ffxx, nxx)
use inputs
use params		!reads in parameters from params.inp
use wageproc	!defines the Markov process for primary and secondary earners using quadrature  
use assetgrid !defines bounds on the cash-in-hand dimension
use subrout   !transfers current state between routines (old common)
use equations !subroutines for solving optimisation step in recursion
use reservat  !solving for reservation cash-in-hand (cash level above which choose not to work
use simulate  !for simulating the model once a solution is found
use banner
use statistics
use summaryindex
use makutility

implicit none

integer a, ier, ifail, i,j, nn,	node, nodebit,nodeas,  p, t, w, xm, xtonon, xtoemp, ww, pp, &
    istart, iend, istart2, iend2, ri
	
integer:: nxx

double precision cons, connon, ediff,diff2, maxspd, minpt,&
resass,  value, valuenon, valnonold, leisemp, & 
valold, withemp, withnon, withnonold, time1a, time2a,time3a, total

double precision, allocatable :: asscut_tmp(:), valemp_tmp(:), withemp_tmp(:), leisemp_tmp(:), valun_tmp(:), withun_tmp(:)
double precision, allocatable :: asscut_tmptot(:), valemp_tmptot(:), withemp_tmptot(:), leisemp_tmptot(:), valun_tmptot(:), withun_tmptot(:)

double precision:: xx(nxx), ffxx(nxx)

INTEGER(2) hour, minute, second,hund

character(len=4)   :: cid


double precision:: minres,value2,withemp2,valuenon2,withnon2, check

time1a = 0.d0 
time2a = 0.d0
time3a = 0.d0 
!call cpu_time( time1a )  

if ( id .lt. 10 ) then
     write(cid,'(i1)') id
else if ( id .lt. 100 ) then
     write(cid,'(i2)') id
end if
     

!1-------------ALLOCATE MEMORY-----------------------------------------------------------------------------

if (firstcall.eq.1) then 

        call reading2( ier )
        if (ier.ne.0) then 
            write (*,*) 'trouble reading data in id ', ier, id
        endif

        call allocate_wageproc_perm(ier)
        if (ier.ne.0) then
	        write (*,*) 'trouble in allocating wage arrays in id ', ier, id
        endif

        call allocate_wageproc_temp(ier)
        if (ier.ne.0) then
	        write (*,*) 'trouble in allocating temp wage arrays in id ', ier, id
        endif

        call allocate_partproc_temp(ier)
        if (ier.ne.0) then
	        write (*,*) 'trouble in allocating temp partner arrays in id ', ier, id
        endif
        call allocate_simulate(ier)
        if (ier.ne.0) then
	        write (*,*) 'trouble inallocating simul arrays in id ', ier, id
        endif
        

       
endif

!2--------------OPEN FILES-----------------------------------------------------------------------------



if (id.eq.0) then 
    !open (unit=20, file ='../Outputs/sims.out')
	open (unit=21, file ='../Outputs/GridPointsVisited.out')
!	open (unit=9996, file ='../Outputs/CornersUmim.out')
!	open (unit=9997, file ='../Outputs/CornersUmax.out')
!	open (unit=9998, file ='../Outputs/CornersEmim.out')
!	open (unit=9999, file ='../Outputs/CornersEmax.out')
    
endif


!3-------------INITIALIZED VALUES---------------------------------------------------------------

!!!!!!!!!!!!!!!!parameters!!!!!!!!!!!!!!!!!!!
do i=1,npar
     modpars(i)  = xx(i) !grid search
enddo



chi        = modpars(1)  !no se usa

utpart3       = modpars(2)
utpart        = modpars(3)
utpart2       = modpars(4)


kidalpha0   = (1-quarter)*modpars(5) + quarter*0.25d0*modpars(5)
deltaper1   = (1-quarter)*modpars(6) + quarter*(1.d0 - (1.d0-modpars(6))**0.25d0)
iniggap     = modpars(7) 

bequest = modpars(10)
mu = modpars(11)

if (olive.eq.1) then 
    oleta1 = modpars(9)
    oleta0 = modpars(8)
    !!oleta0 = -oleta1*63.d0 + modpars(8)
    !modpars(7)      = -modpars(8)*63.d0 + exp(xx(7))                     
    alpha1 = 1.d0           ! is the default for no diminishing returns to human capital. 
elseif (olive.eq.0) then 
    oleta1 = 0.d0 
    alpha1 = modpars(9)       ! = 1.d0 is the default for no diminishing returns to human capital. 
    oleta0 = (1.d0 - alpha1) + modpars(8)
else 
    oleta1 = 0.d0 
    alpha1 = 1.d0 
endif


 !    call cpu_time( time3a )  
  !   write (10,*) 'first setup in partner takes ', time3a-time1a



!!!!!!!!!!!variables!!!!!!!!!!!
begnosims = 1	 
weignosims = 0



totcon= 0.0d0 
toteis= 0.d0
totpay= 0.0d0 
totsav= 0.0d0
totfixed= 0.0d0
totpaypart= 0.0d0
varcon= 0.d0
varpay= 0.d0 
nonlin= 0.d0
partip= 0.d0
totexp= 0.d0
totexpun=0.d0

partnomot = 0.d0 
nomot = 0


totgappay = 0.d0 
totgappart = 0.d0 
    
visitemp = 0
visitnon = 0

wealth = 0.d0


maxpartcash=-10000000.d0

growthY=0.d0
countpartY=0
growthO=0.d0
countpartO=0

numsimsurv=0

!call cpu_time( time1a )  
!write (10,*) 'second setup in partner takes ', time1a-time3a







!4------------SOLVING MODEL----------------------------------------------------------------

MPI_N = ntotal/nproc 
itemp = ntotal - MPI_N*nproc
if (itemp>0) MPI_N=MPI_N+1	!!!!ntotal NOT equal to mpi_n*nproc if itemp>0
istart = id*MPI_N +1
iend = min((id+1)*MPI_N,ntotal)


MPI_N2 = ntotal2/nproc 
itemp = ntotal2 - MPI_N2*nproc
if (itemp>0) MPI_N2=MPI_N2+1	!!!!ntotal2 NOT equal to mpi_n*nproc if itemp>0
istart2 = id*MPI_N2 +1
iend2 = min((id+1)*MPI_N2, ntotal2)



allocate (valemp_tmp(MPI_N2), withemp_tmp(MPI_N2), valun_tmp(MPI_N2), withun_tmp(MPI_N2), withun_tmptot(MPI_N2*NPROC)  )    
allocate(valun_tmptot(MPI_N2*NPROC), valemp_tmptot(MPI_N2*NPROC),  withemp_tmptot(MPI_N2*NPROC) )


do ki=1,10

    !maternity type
	!cohort born in 1940s: average age at first= 22
    if(ki<=5)then
        agekid = -4   !young mothers
    else  
        agekid = 1    !old mothers
    endif
	
	

	if(ki==1.or.ki==6)ntH=37 !62
    if(ki==2.or.ki==7)ntH=38 !63
    if(ki==3.or.ki==8)ntH=39 !64
	if(ki==4.or.ki==9)ntH=40 !65
	if(ki==5.or.ki==10)ntH=41 !66
	
	    
    if(ki==1)then
        begnosims = 1  !adding number at j=1 to begin number
    else
        begnosims = 1 + int(sum(propkid(1:ki-1))*nosims)
    endif
    weignosims =  int(sum(propkid(1:ki))*nosims)	
  
	!begnosims  = 1
    !weignosims = nosims
	
if(ID==0)write(*,*)'ki',ki, begnosims, weignosims

call modpar
call markovwagepr
call gridpension
							 
do t=1,nt
	fixed(t) =  infants(t) 
enddo
		
call bounds



!set all solutions to wild	
valr			= -1.d100
valrW			= -1.d100
valrWh			= -1.d100
withr		= -1.d100
withrW		= -1.d100
withrWh		= -1.d100
valun		= -1.d100
withun		= -1.d100
valemploy	= -1.d100
withemploy  = -1.d100
asscut      = -1.d10
	

! loop backwards in time
!I-COMPULSORY RETIREMENT STAGE and START CLAIMING: FROM nt+1 TO nt+ret
do t=nt+ret,nt+1,-1
		
		if(ID==0)write(*,*)t

		age   = t
		ageto = age +1
		!xanon() is not contingent on states from t=nt+1 to nt+ret.All states share 
		!the same grid in the retirement period
        call gridret(1,1,age)

		ageret=t-nt
	    !couples
	        do p=1,pnw
	            pnode = p
	            do w=1,nw
				!w=1
				    wnodepen = w
				    do xm=1,nretage !noexp
						!xm=1
				        xvalue = xm
	                    !nodeas = sumindex(nmindex,(/w,p,xm/))

	                    do a=1,na
	    	                partcash = xaret(a,1,age)

					        call valret(valuenon,withnon)
					        !valnon solves for consumption (ie connon=withnon)
					        node = sumindex(nmindex2,(/w,p,xm,a/))
					  !~      valun(node, age)  = valuenon
					  !~      withun(node, age) = withnon
							valr(node, age)  = valuenon
					        withr(node, age) = withnon
							
						   			
	                    enddo
	                enddo
	           enddo
	        enddo
			
!			if(ID.eq.0)write(*,*)'end call valret'
			!widows-females
	        do p=1,pnw
	            pnode = p
	            do w=1,nw			
				    wnodepen = w
				    do xm=1,nretage !noexp
						!xm=1
				        xvalue = xm
	                    !!!!nodeas = sumindex(nmindex,(/w,p,xm/))

	                    do a=1,na
	    	                partcash = xaret(a,1,age)
                            
					        call valretW(valuenon,withnon)
					        !valnon solves for consumption (ie connon=withnon)
					        node = sumindex(nmindex2,(/w,p,xm,a/))
					        valrW(node, age)  = valuenon
					        withrW(node, age) = withnon
                           				
	                    enddo
	                enddo
	           enddo
	        enddo
			!if(ID.eq.0)write(*,*)'end call valretW'
			
			do p=1,pnw
	            pnode = p
	            !do w=1,nw
				w=1    !I assume males always get their own pension, so no need to keep track of female earnings
				    wnodepen = w
				    !do xm=1,noexp
						xm=1  
				        xvalue = xm
	                    !!!!nodeas = sumindex(nmindex,(/w,p,xm/))

	                    do a=1,na
	    	                partcash = xaret(a,1,age)
                            
					        call valretWh(valuenon,withnon)
					        !valnon solves for consumption (ie connon=withnon)
					        node = sumindex(nmindex2,(/w,p,xm,a/))
					        valrWh(node, age)  = valuenon
					        withrWh(node, age) = withnon
							
							
                           				
	                    enddo
	                !enddo
	           !enddo
	        enddo
			!if(ID.eq.0)write(*,*)'end call valretWh'
			
			
enddo		!t=nt+ret,nt+1,-1	 


!II-NON-PENSION ELIGIBLE STAGE (FROM 1 TO nt) 
do t=nt,1,-1   

	age   = t
	ageto = t+1
	if(ID==0)write(*,*)t


		!1-RESERVATION ASSET 
		!----------------------------------------------------------------------------------------------------------------------------

!~        do ri=1,MPI_N
!~            asscut_tmp(ri) = -1.d10 
!~        enddo
!~
!~		 finishasscut=0
!~         do ri= istart,iend
!~          
!~            sindex = inv_sumindex(nmindex,ri)   
!~            w=sindex(1)
!~            p=sindex(2)
!~            xm = sindex(3) 
!~
!~		    wnode = w
!~            pnode = p
!~            !part = pxw(p,t)
!~            part = pxw(p,t)- payrolltax(part)
!~
!~			xvalue = xm
!~			!wage   = xw(w,t) * expvalue(xm,t) 
!~            wage   = xw(w,t) * ryearsexp(expvalue(xm,t))
!~			solutiongrid=0
!~			
!~			if(xvalue.le.t)then  !solve only for feasible cases: note that years of experience cannot be greater than age counter
!~				call reserve2(resass)
!~			endif
!~			!find reservation asset stock: at what level of assets does the individual stops working given the alph 
!~			asscut_tmp(ri-istart+1) = resass
!~		
!~	    enddo
!~        
!~        call MPI_Barrier(MPI_COMM_WORLD,ierr)
!~        call MPI_AllGATHER(asscut_tmp(1),MPI_N,MPI_DOUBLE_PRECISION,asscut_tmptot(1),MPI_N,MPI_DOUBLE_PRECISION, MPI_COMM_WORLD, ierr ) 
!~        do ri=1,ntotal
!~	        asscut(ri,age)=asscut_tmptot(ri)
!~        enddo
!~        call MPI_Barrier(MPI_COMM_WORLD,ierr)
        
        !2-GRIDS
		!----------------------------------------------------------------------------------------------------------------------------
        do ri=1,ntotal
	        sindex = inv_sumindex(nmindex,ri)   
            xvalue = sindex(3) 
			if(xvalue.le.t)then
			call grid(xvalue,ri,age)
			!same grid for employed and unemployed
            !call gridnon(xvalue,ri,age) 
			
            endif
        enddo
		xanon=xawork
   
        call MPI_Barrier(MPI_COMM_WORLD,ierr) 
  !~      do ri=1,ntotal
	 !~       sindex = inv_sumindex(nmindex,ri)   
  !~          xvalue = sindex(3) 
		!~	
		!~	if(xvalue.le.t)then	!solve only for feasible cases: note that years of experience cannot be greater than age counter
		!~	   if (asscut(ri,age).gt.alow(xvalue,age)+xtol) then
		!~		
		!~			call grid(xvalue,ri,age)		 !grid below reserv ass
		!~	
		!~		else	
		!~			asscut(ri,age) = alow(xvalue,age) - 1.d100
		!~		endif
		!~	endif
		!~enddo
  !~      call MPI_Barrier(MPI_COMM_WORLD,ierr)
      

  
   
	!3-LOOP TO SOLVE AT EACH POINT OF THE STATE SPACE
	!----------------------------------------------------------------------------------------------------------------------------
	
	solutiongrid=1
	
	
    do ri=1,MPI_N2
            valemp_tmp(ri)  = -1.d10
            withemp_tmp(ri) = -1.d10
            valun_tmp(ri)   = -1.d10
            withun_tmp(ri)  = -1.d10
     enddo


		finishasscut=1
        do ri=istart2,iend2

			call cpu_time( time1a ) 

            sindex2 = inv_sumindex(nmindex2,ri)            

            w=sindex2(1)
            p=sindex2(2)
            xm = sindex2(3) 
            a = sindex2(4)

			anode = a               
            wnode = w
            pnode = p
            part = pxw(p,t)

		    xvalue = xm

			if(t.lt.nt)then
				xtoemp = max(mapping( t,xm, 1),1) !assume min hours to define minincome
				xtonon = max(mapping( t,xm, 0),1)
			else
				xtoemp = 1
				xtonon = 1
			endif

            !wage      = xw(w,t) *  expvalue(xm,t) 
            wage   = xw(w,t) * ryearsexp(expvalue(xm,t))
			
		    nodeas = sumindex(nmindex,(/w,p,xm/))

            !state variable for cash-in-hand if working

	        node		= ri 
	        partcash	= xawork(a,nodeas, age) 
			
			

			!3.1--VALUE FUNCTION OF EMPLOYED 
			if(xm.le.t)then   !solve only for realistic cases: note that years of experience cannot be greater than age counter
				if (partcash +wage*hoursfix-payrolltax(wage*hoursfix)-fixed(t).gt.0.d0) then


						call valemp(value,withemp,leisemp)  !this solves for the optimal value function
						
															!at this point in the state space
						
					
						
						valemp_tmp(ri-istart2+1)  = value
						withemp_tmp(ri-istart2+1) = withemp
						
								
				endif 			
			endif  !xm.lt.t
			
		    !3.2--VALUE FUNCTION OF UNEMPLOYED
		    if(xm.le.t)then   !solve only for realistic cases: note that years of experience cannot be greater than age counter
				!if (asscut(nodeas,age).lt.ahigh(age)) then 
						
						partcash = xanon(a,nodeas, age)

						if (partcash+mininc(xtonon,age).lt.-1.d-8) then !not work gives neg consumption

							write (*,*) 'problem in non solution ',ID
							

						elseif (partcash.ge.0.d0) then
						
							
								call valnon(valuenon,withnon)
								  
														
								valun_tmp(ri-istart2+1)  = valuenon
								withun_tmp(ri-istart2+1) = withnon
								
						endif

				
				!endif
		    endif


    enddo !end of ri loop

    
  
	!save 

    valun_tmptot=-1.d100
    call MPI_Barrier(MPI_COMM_WORLD,ierr)
    call MPI_AllGATHER(valun_tmp(1),MPI_N2,MPI_DOUBLE_PRECISION,valun_tmptot(1),MPI_N2,MPI_DOUBLE_PRECISION, MPI_COMM_WORLD, ierr ) 
    do ri=1,ntotal2
	    valun(ri,age)=valun_tmptot(ri)
    enddo

    withun_tmptot=-1.d100
    call MPI_Barrier(MPI_COMM_WORLD,ierr)
    call MPI_AllGATHER(withun_tmp(1),MPI_N2,MPI_DOUBLE_PRECISION,withun_tmptot(1),MPI_N2,MPI_DOUBLE_PRECISION, MPI_COMM_WORLD, ierr ) 
    do ri=1,ntotal2
	    withun(ri,age)=withun_tmptot(ri)
    enddo

    valemp_tmptot = -1.d100
    call MPI_Barrier(MPI_COMM_WORLD,ierr)
    call MPI_AllGATHER(valemp_tmp(1),MPI_N2,MPI_DOUBLE_PRECISION,valemp_tmptot(1),MPI_N2,MPI_DOUBLE_PRECISION, MPI_COMM_WORLD, ierr ) 
    do ri=1,ntotal2
	    valemploy(ri,age)=valemp_tmptot(ri)
    enddo

    withemp_tmptot=-1.d100
    call MPI_Barrier(MPI_COMM_WORLD,ierr)
    call MPI_AllGATHER(withemp_tmp(1),MPI_N2,MPI_DOUBLE_PRECISION,withemp_tmptot(1),MPI_N2,MPI_DOUBLE_PRECISION, MPI_COMM_WORLD, ierr ) 
    do ri=1,ntotal2
	    withemploy(ri,age)=withemp_tmptot(ri)
    enddo


    call MPI_Barrier(MPI_COMM_WORLD,ierr)

	
enddo !end loop on age, backwards

solutiongrid=2
!5---------------SIMULATE-----------------------------------------------------------------------
call empsim				 !simulation routine once the numerical solution is found

!if(ID.eq.0)write(*,*)'end empsim',ki,iwage(1,1) 


enddo !end of loop over ki


deallocate (valemp_tmp, withemp_tmp, valun_tmp, withun_tmp, withun_tmptot )
deallocate(valun_tmptot, valemp_tmptot, withemp_tmptot)

!deallocate(leisemp_tmptot )


!6---------------STATISTICS-----------------------------------------------------------------------
call simulstats

!calibration error!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
do j=1,npar
    ffxx(j) = calibstats(j)
enddo
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


666  continue

9999 format (5(3x,e14.6))
9998 format (5(2x,e14.6))

7888 format (e14.6)
8888 format (E14.6, 2(2x,I4), 3(3x,e14.6))
8887 format ( 3(I6,2X), e16.6 )   

RETURN


900 continue

end subroutine partner



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
